using BloqadeSchema
using Bloqade
using JSON

# max number of atoms (256) arranged in various configurations

# square lattice 
atoms = generate_sites(SquareLattice(), 16, 16; scale = 4.5)

# Lieb lattice 
# atoms = generate_sites(LiebLattice(), 10, 8; scale = 4.5)

# TriangularLattice
# atoms = generate_sites(TriangularLattice(), 16, 16; scale = 3.2)

T=1
Δ = Waveform(t->cos(2π*t/T),T)
Δi=Δ
ϕ = constant(;duration=T, value=0)
Ω = constant(;duration=T, value=0)

h = rydberg_h(atoms;Δ=Δi,ϕ=ϕ,Ω=Ω)
h_hardware, info = hardware_transform(h)
h = to_json(h_hardware)


open("lib/BloqadeSchema/schema_examples/aws_science_tasks/lattice_programmability/lattice3.json","w") do f
    JSON.print(f, JSON.parse(h))
end

using BloqadeSchema
using Bloqade
using JSON

# sites are spaced less than the minimum distance apart
atoms = AtomList([(0.0, 0.0), (0.0, 0.8), (0.0, 3.4), (0.0, 5.0)])

T=1
Δ = Waveform(t->cos(2π*t/T),T)
Δi=Δ
Ω = constant(;duration=T, value=0)
ϕ = constant(;duration=T, value=0)

h = rydberg_h(atoms;Δ=Δi,Ω=Ω,ϕ=ϕ)
h_hardware,info = hardware_transform(h)
h = to_json(h_hardware)


open("lib/BloqadeSchema/schema_examples/aws_science_tasks/lattice_programmability/lattice2.json","w") do f
    JSON.print(f, JSON.parse(h))
end

using BloqadeSchema
using Configurations
using Test

if "docstring" in ARGS
    include("docstrings.jl")
    exit()
end

@testset "capabilities" begin
    include("capabilities.jl")
end

@testset "parse" begin
    include("parse.jl")
end

# TODO: add tests
@testset "transform" begin
    include("transform.jl")
end

# TODO: add tests 
@testset "validate" begin
    include("validate.jl")
end

# TODO: rework tests for execute.
@testset "execute" begin
    include("execute.jl")
end

@testset "types" begin
    include("types.jl")
end

@testset "to_braket_ahs_ir" begin
    include("to_braket_ahs_ir.jl")
end

# @testset "serialize" begin
#     include("serialize.jl")
# end

using BloqadeLattices
using BloqadeExpr
using BloqadeSchema
using BloqadeWaveforms
# using Braket
using DecFP

random_times  = collect(0:9)
random_values = random_coefficients = rand(-10:10e-5:100,10)
rand_sites = [site for site in zip(rand(0:1e-7:100,10), rand(0:1e-7:100,10))]
lattice = BloqadeSchema.Lattice(
    sites = rand_sites,
    filling = fill(1, length(rand_sites))
)

@testset "Lattice" begin

    setup = to_braket_ahs_ir(lattice)
    # filling should be equal to number of atom positions
    @test length(setup.ahs_register.filling) === length(setup.ahs_register.sites)
    # atom positions should be the same from the original 
    converted_sites = map(lattice.sites) do site
        Dec128.(string.([site...]))
    end
        
    @test converted_sites == setup.ahs_register.sites
end


local_detuning = BloqadeSchema.LocalField(
    random_times,
    random_values,
    random_coefficients
)
@testset "LocalField" begin
    
    # to_braket_ahs_ir(local_value::BloqadeSchema.LocalField)

    physical_field = to_braket_ahs_ir(local_detuning)
    # check that values remain consistent
    
    @test Dec128.(string.(random_times)) == physical_field.time_series.times
    @test Dec128.(string.(random_values)) == physical_field.time_series.values
    @test Dec128.(string.(random_coefficients)) == physical_field.pattern

end

amplitude_global = BloqadeSchema.GlobalField(
    random_times,
    random_values
)

global_phase = BloqadeSchema.GlobalField(
    random_times,
    random_values
)
global_detuning = BloqadeSchema.GlobalField(
    random_times,
    random_values
)
@testset "Globals" begin

    # to_braket_ahs_ir(global_values::Union{BloqadeSchema.GlobalField,
    # BloqadeSchema.GlobalField,
    # BloqadeSchema.GlobalField})
    @testset "GlobalField" begin

        physical_field = to_braket_ahs_ir(amplitude_global)
        @test Dec128.(string.(random_times)) == physical_field.time_series.times
        @test Dec128.(string.(random_values)) == physical_field.time_series.values
        @test "uniform" == physical_field.pattern
    end

    @testset "GlobalField" begin
        physical_field = to_braket_ahs_ir(global_phase)
        @test Dec128.(string.(random_times)) == physical_field.time_series.times
        @test Dec128.(string.(random_values)) == physical_field.time_series.values
        @test "uniform" == physical_field.pattern
    end

    @testset "GlobalField" begin
        physical_field = to_braket_ahs_ir(global_detuning)
        @test Dec128.(string.(random_times)) == physical_field.time_series.times
        @test Dec128.(string.(random_values)) == physical_field.time_series.values
        @test "uniform" == physical_field.pattern
    end

end

rydberg_amplitude = BloqadeSchema.RabiFrequencyAmplitude(amplitude_global)
rydberg_phase = BloqadeSchema.RabiFrequencyPhase(global_phase)
@testset "Unwrap Globals" begin

    # to_braket_ahs_ir(amplitude_or_phase::Union{BloqadeSchema.RabiFrequencyAmplitude,
    # BloqadeSchema.RabiFrequencyPhase})

    random_times  = collect(0:9)
    random_values = rand(-10:10e-5:100,10)

    @testset "RabiFrequencyAmplitude" begin

        physical_field = to_braket_ahs_ir(rydberg_amplitude)
        @test Dec128.(string.(random_times)) == physical_field.time_series.times
        @test Dec128.(string.(random_values)) == physical_field.time_series.values
        @test "uniform" == physical_field.pattern
    end

    @testset "RabiFrequencyPhase" begin

        physical_field = to_braket_ahs_ir(rydberg_phase)
        @test Dec128.(string.(random_times)) == physical_field.time_series.times
        @test Dec128.(string.(random_values)) == physical_field.time_series.values
        @test "uniform" == physical_field.pattern
    end
end

detunings_without_local = BloqadeSchema.Detuning(
                            global_detuning,
                            nothing
                        )

detunings_with_local = BloqadeSchema.Detuning(
                            global_detuning,
                            local_detuning
                        )
BloqadeSchema.LocalField(
                            random_times, 
                            random_values,
                            random_coefficients
                        )
@testset "Detuning" begin
    # function to_braket_ahs_ir(detuning::BloqadeSchema.Detuning) 

    @testset "without local detuning" begin
        Δ, δ = to_braket_ahs_ir(detunings_without_local)
        # Δ should be 
        @test δ === nothing
        @test Dec128.(string.(random_times)) == Δ.time_series.times
        @test Dec128.(string.(random_values)) == Δ.time_series.values
        @test "uniform" == Δ.pattern

    end


    @testset "with local detuning" begin

        Δ, δ = to_braket_ahs_ir(detunings_with_local)

        @test Dec128.(string.(random_times)) == δ.time_series.times
        @test Dec128.(string.(random_values)) == δ.time_series.values
        @test Dec128.(string.(random_coefficients)) == δ.pattern

        @test Dec128.(string.(random_times)) == Δ.time_series.times
        @test Dec128.(string.(random_values)) == Δ.time_series.values
        @test "uniform" == Δ.pattern
    end
end

rydberg_hamiltonian = BloqadeSchema.RydbergHamiltonian(
                        rydberg_amplitude,
                        rydberg_phase,
                        detunings_with_local
                    )

effective_hamiltonian = BloqadeSchema.EffectiveHamiltonian(
                            rydberg_hamiltonian
                        )

@testset "EffectiveHamiltonian" begin 

    # function to_braket_ahs_ir(hamiltonian::BloqadeSchema.EffectiveHamiltonian)

    hamiltonian = to_braket_ahs_ir(effective_hamiltonian) 
    @test length(hamiltonian.drivingFields) === 1
    @test length(hamiltonian.shiftingFields) === 1

    h_amplitude = hamiltonian.drivingFields[1].amplitude
    h_phase     = hamiltonian.drivingFields[1].phase
    h_detuning  = hamiltonian.drivingFields[1].detuning

    @test Dec128.(string.(random_times))  == h_amplitude.time_series.times
    @test Dec128.(string.(random_values)) == h_amplitude.time_series.values
    @test "uniform" == h_amplitude.pattern

    @test Dec128.(string.(random_times))  == h_phase.time_series.times
    @test Dec128.(string.(random_values)) == h_phase.time_series.values
    @test "uniform" == h_phase.pattern

    @test Dec128.(string.(random_times))  == h_detuning.time_series.times
    @test Dec128.(string.(random_values)) == h_detuning.time_series.values
    @test "uniform" == h_detuning.pattern
    
end

@testset "RydbergHamiltonian" begin
    
    # function to_braket_ahs_ir(hamiltonian::BloqadeSchema.RydbergHamiltonian)

    hamiltonian = to_braket_ahs_ir(rydberg_hamiltonian) 
    @test length(hamiltonian.drivingFields) === 1
    @test length(hamiltonian.shiftingFields) === 1

    h_amplitude = hamiltonian.drivingFields[1].amplitude
    h_phase     = hamiltonian.drivingFields[1].phase
    h_detuning  = hamiltonian.drivingFields[1].detuning

    @test Dec128.(string.(random_times))  == h_amplitude.time_series.times
    @test Dec128.(string.(random_values)) == h_amplitude.time_series.values
    @test "uniform" == h_amplitude.pattern

    @test Dec128.(string.(random_times))  == h_phase.time_series.times
    @test Dec128.(string.(random_values)) == h_phase.time_series.values
    @test "uniform" == h_phase.pattern

    @test Dec128.(string.(random_times))  == h_detuning.time_series.times
    @test Dec128.(string.(random_values)) == h_detuning.time_series.values
    @test "uniform" == h_detuning.pattern
end

@testset "QuEraTaskSpecification" begin
    task_specification = BloqadeSchema.QuEraTaskSpecification(
                            1000,
                            lattice,
                            effective_hamiltonian
                        )

    ahs_program = to_braket_ahs_ir(task_specification)

    # check header
    @test "braket.ir.ahs.program" == ahs_program.braketSchemaHeader.name
    @test "1" == ahs_program.braketSchemaHeader.version

    # check positions
    setup = ahs_program.setup
    @test length(setup.ahs_register.filling) === length(setup.ahs_register.sites)
    converted_sites = map(lattice.sites) do site
        Dec128.(string.([site...]))
    end
    @test converted_sites == setup.ahs_register.sites

    # check hamiltonian
    hamiltonian = ahs_program.hamiltonian

    @test length(hamiltonian.drivingFields) === 1
    @test length(hamiltonian.shiftingFields) === 1

    h_amplitude = hamiltonian.drivingFields[1].amplitude
    h_phase     = hamiltonian.drivingFields[1].phase
    h_detuning  = hamiltonian.drivingFields[1].detuning

    @test Dec128.(string.(random_times))  == h_amplitude.time_series.times
    @test Dec128.(string.(random_values)) == h_amplitude.time_series.values
    @test "uniform" == h_amplitude.pattern

    @test Dec128.(string.(random_times))  == h_phase.time_series.times
    @test Dec128.(string.(random_values)) == h_phase.time_series.values
    @test "uniform" == h_phase.pattern

    @test Dec128.(string.(random_times))  == h_detuning.time_series.times
    @test Dec128.(string.(random_values)) == h_detuning.time_series.values
    @test "uniform" == h_detuning.pattern

end

module BloqadeSchema

using Unitful: Unitful, Quantity, m, μm, μs, s, rad, uconvert
using BloqadeExpr
using BloqadeWaveforms
using BloqadeODE: SchrodingerProblem
using Roots:find_zero,Brent
using Configurations
using Yao
using JSON
using BitBasis
using LinearAlgebra: svd
using AWS
using Braket
using DecFP

export get_device_capabilities,
    get_device_capabilities_SI,
    hardware_transform_Ω,
    hardware_transform_ϕ,
    hardware_transform_Δ,
    hardware_transform_atoms,
    hardware_transform,
    HardwareTransformInfo,
    validate,
    to_json,
    to_json_no_validation,
    to_dict,
    SchemaTranslationParams,
    to_schema,
    to_braket_ahs_ir,
    to_schema_no_validation,
    from_json,
    from_dict,
    from_schema,
    execute,
    submit_to_braket,
    QuEraTaskSpecification,
    TaskOutput,
    ValidationViolations

include("schemas/ahs_ir.jl")
include("schemas/ahs_capabilities.jl")
include("types.jl")
include("capabilities.jl")
include("serialize.jl")
include("deserialize.jl")
include("parse.jl")
include("validate.jl")
include("transform.jl")
include("execute.jl")
include("to_braket_ahs_ir.jl")
include("submit_to_braket.jl")
include("observables.jl")

end

using BloqadeSchema
using Bloqade
using JSON


#  1D scar dynamics. For more details, see https://queracomputing.github.io/Bloqade.jl/dev/tutorials/3.quantum-scar/main/

nsites = 9
atoms = generate_sites(ChainLattice(), nsites, scale = 5.72)

Δ1 = piecewise_linear(clocks = [0.0, 0.3, 1.6, 2.2], values = 2π * [-10.0, -10.0, 10.0, 10.0]);
Ω1 = piecewise_linear(clocks = [0.0, 0.05, 1.6, 2.2], values = 2π * [0.0, 4.0, 4.0, 0.0]);

Ω2 = constant(duration = 2.0, value = 2 * 2π);
Δ2 = constant(duration = 2.0, value = 0);

Ω_tot = append(Ω1, Ω2);
Δ_tot = append(Δ1, Δ2);

ϕ = constant(duration = 4.2, value = 0);

h = rydberg_h(atoms; Δ = Δ_tot, Ω = Ω_tot, ϕ=ϕ)
device_capabilities = get_device_capabilities()
# WARNING: This will result in invalid JSON file for actual QPU.
device_capabilities.rydberg.global_value.timeMax = 5
h_hardware, info = hardware_transform(h, device_capabilities=device_capabilities)
h = to_json(h_hardware; device_capabilities)

open("lib/BloqadeSchema/schema_examples/tutorial_examples/1D_scar.json","w") do f
    JSON.print(f, JSON.parse(h))
end

using Test 
using Unitful
using BloqadeWaveforms:
    Waveform,
    piecewise_linear,
    piecewise_constant
using BloqadeSchema:
    TaskCapabilities,
    check_resolution,
    message,
    get_rydberg_capabilities,
    get_device_capabilities,
    set_resolution,
    check_durations,
    validate_Ω,
    validate_Δ,
    validate_ϕ,
    validate_lattice,
    validate
using BloqadeExpr:
    rydberg_h
using BloqadeLattices

@testset "check_resolution" begin
    # check if x is integer multiple of res,
    # return false if x is, otherwise return true
    @test check_resolution(0.001, 0.0) == false
    @test check_resolution(0.001, 10.0) == false
    @test check_resolution(0.037, 9.0)

end

@testset "message" begin

    @test message(>) == "exceeds maximum"
    @test message(<) == "below minimum"
    @test message(!=) == "is not equal to the"

end

@testset "validate_lattice" begin
    # example for each error
    dc = get_device_capabilities()


    # maximum qubits
    nqubits_max = dc.lattice.number_qubits_max
    atoms = generate_sites(SquareLattice(),17,16,scale=4)
    nqubits = length(atoms)
    violations = validate_lattice(atoms,dc)

    @test violations == Set(["$nqubits qubits $(message(>)) of $nqubits_max qubits"])

    # position resolution
    position_resolution = dc.lattice.geometry.position_resolution
    position = (9*position_resolution/10,0)
    atoms = [position]
    violations = validate_lattice(atoms,dc)
    @test violations == Set(["1th atom position $position not consistent with position resolution: $position_resolution"])

    # maximum width
    max_width = dc.lattice.area.width
    width = max_width+1
    atoms = [(0,0),(width,0)]
    violations = validate_lattice(atoms,dc)
    @test violations == Set(["total width $width μm $(message(>)) value of $max_width μm"])


    # maximum height
    max_height = dc.lattice.area.height
    height = max_height+1
    atoms = [(0,0),(0,height)]
    violations = validate_lattice(atoms,dc)
    @test violations == Set(["total height $height μm $(message(>)) value of $max_height μm"])

    # radial distance
    ## NOTE: minimum supported radial distance is equal to the minimum supported vertical distance
    radial_spacing_min = dc.lattice.geometry.spacing_radial_min
    vertical_resolution = dc.lattice.geometry.spacing_vertical_min
    radial_spacing = 0.9 * radial_spacing_min
    v_1 = (0,0)
    v_2 = (0,radial_spacing)
    atoms = [v_1,v_2]
    violations = validate_lattice(atoms,dc)
    @test violations == Set([
        "positions {1 => $v_1, 2 => $v_2} violate y minimum value of $vertical_resolution μm",
        "positions 1 => $v_1 and 2 => $v_2 are a distance of $radial_spacing μm apart which is $(message(<)) value of $radial_spacing_min μm",
    ])


    v_1 = (0,0)
    v_2 = (5,2*vertical_resolution-0.1)
    v_3 = (10,vertical_resolution-0.1)
    v_4 = (15,0)
    atoms = [v_1,v_2,v_3,v_4]
    error_sites = join([site=>atoms[site] for site in [1,3,4]],", ")
    violations = validate_lattice(atoms,dc)
        
    @test violations == Set(["positions {$(error_sites)} violate y minimum value of $vertical_resolution μm"])


end

@testset "validate_Ω" begin

    rydberg_capabilities = get_rydberg_capabilities()

    max_time = rydberg_capabilities.Ω.max_time
    # waveform duration cannot exceed maximum supported time
    Ω = piecewise_linear(;clocks = [0.0,1.0,2.0,3.0,max_time + 0.1], values = fill(0.0, 5))
    @test validate_Ω(Ω, rydberg_capabilities.Ω) == Set([
        "Ω(t) duration with value $(max_time + 0.1) μs exceeds maximum value of $max_time μs"
    ])

    # waveform cannot have duration smaller than minimum allowable time step
    # can give two warnings: waveform duration is shorter than supported minimum time step
    #                        AND minimum time step is shorter than supported minimum time step

    min_time_step = rydberg_capabilities.Ω.min_time_step
    Ω = piecewise_linear(clocks = [0.0, min_time_step - 0.01], values = [0.0, 0.0])
    @test validate_Ω(Ω, rydberg_capabilities.Ω)== Set([
        "Ω(t) duration with value $(min_time_step - 0.01) μs below minimum value of $min_time_step μs",
        "Ω(t) minimum step with value $(min_time_step - 0.01) μs below minimum value of $min_time_step μs"
    ])

    # waveform minimum time step cannot be smaller than supported minimum (0.01 microseconds)
    Ω = piecewise_linear(clocks = [0.0, 0.01, 0.011, 0.1], values=fill(0.0, 4))
    @test validate_Ω(Ω, rydberg_capabilities.Ω) == Set([
        "Ω(t) minimum step with value 0.001 μs below minimum value of $min_time_step μs"
    ])

    # initial value must be 0.0 radians
    Ω = piecewise_linear(;clocks=[0.0,0.1,1.0,2.0], values=[0.1,0.5,0.9,0.0])
    @test validate_Ω(Ω, rydberg_capabilities.Ω) == Set([
        "Ω(t) start value with value 0.1 rad/μs is not equal to the value of 0.0 rad/μs"
    ])

    # end value must be 0.0 radians
    Ω = piecewise_linear(;clocks=[0.0,0.1,1.0,2.0], values=[0.0,0.5,0.9,1.0])
    @test validate_Ω(Ω, rydberg_capabilities.Ω) == Set([
        "Ω(t) end value with value 1.0 rad/μs is not equal to the value of 0.0 rad/μs"
    ])

    supported_max_slope = rydberg_capabilities.Ω.max_slope
    end_value = set_resolution(supported_max_slope*1.01 * 0.05, rydberg_capabilities.Ω.value_resolution)
    slope = end_value/0.05
    Ω = piecewise_linear(clocks = [0.0, 0.05, 1.0, 4.0], values = [0.0, end_value, end_value, 0])
    @test validate_Ω(Ω, rydberg_capabilities.Ω) == Set([
        "Ω(t) maximum slope with value $(slope) rad/μs² exceeds maximum value of $supported_max_slope rad/μs²"
    ])

    supported_min_value = rydberg_capabilities.Ω.min_value
    Ω = piecewise_linear(clocks = [0.0, 2.0, 4.0], values = [0.0, supported_min_value-0.1,0.0])
    @test validate_Ω(Ω, rydberg_capabilities.Ω) == Set([
        "Ω(t) minimum value with value $(supported_min_value-0.1) rad/μs below minimum value of $supported_min_value rad/μs"
    ])

    supported_max_value = rydberg_capabilities.Ω.max_value
    # cannot go below hardware supported minimum value
    Ω = piecewise_linear(;clocks=[0.0,2.0,4.0], values=[0.0, supported_max_value+0.1, 0.0])
    @test validate_Ω(Ω, rydberg_capabilities.Ω) == Set([
        "Ω(t) maximum value with value $(supported_max_value+0.1) rad/μs exceeds maximum value of $supported_max_value rad/μs"
    ])

    # time values must be integer multiple of resolution (0.001 μs)
    Ω = piecewise_linear(;clocks=[0.0,1.0,2.0,3.0,3.9995], values=fill(0.0,5))
    @test validate_Ω(Ω, rydberg_capabilities.Ω) == Set([
        "Ω(t) clock 3.9995 μs is not consistent with resolution 0.001 μs."
    ])

    # waveform values must be integer multiple of resolution (5.0e-7 rad)
    resolution = rydberg_capabilities.Ω.value_resolution
    value = round(11.4*resolution;sigdigits=14)
    Ω = piecewise_linear(;clocks=[0.0, 0.1, 0.2, 0.3], values=[0.0, 10*resolution, value, 0.0])
    @test validate_Ω(Ω, rydberg_capabilities.Ω) == Set([
        "Ω(t) value $value rad/μs is not consistent with resolution $resolution rad/μs."
    ])

end

@testset "validate_Δ" begin

    rydberg_capabilities = get_rydberg_capabilities()

    # waveform duration cannot exceed maximum supported time
    Δ = piecewise_linear(;clocks = [0.0,1.0,2.0,3.0,4.1], values = fill(0.0, 5))
    @test validate_Δ(Δ, rydberg_capabilities.Δ) == Set([
        "Δ(t) duration with value 4.1 μs exceeds maximum value of 4.0 μs"
    ])

    # waveform cannot have duration smaller than minimum allowable time step
    # can give two warnings: waveform duration is shorter than supported minimum time step
    #                        AND minimum time step is shorter than supported minimum time step
    min_time_step = rydberg_capabilities.Δ.min_time_step
    Δ = piecewise_linear(clocks = [0.0,0.009], values = [0.0, 0.0])
    @test validate_Δ(Δ, rydberg_capabilities.Δ)== Set([
        "Δ(t) duration with value $(Δ.duration) μs below minimum value of $min_time_step μs",
        "Δ(t) minimum step with value $(Δ.duration) μs below minimum value of $min_time_step μs"
    ])

    # waveform minimum time step cannot be smaller than supported minimum (0.01 microseconds)
    Δ = piecewise_linear(clocks = [0.0, 0.01, 0.011, 0.1], values=fill(0.0, 4))
    @test validate_Δ(Δ, rydberg_capabilities.Δ) == Set([
        "Δ(t) minimum step with value 0.001 μs below minimum value of $min_time_step μs"
    ])
    
    # violating slope constraint also means violating maximum value constraint
    supported_max_slope = rydberg_capabilities.Δ.max_slope
    end_value = set_resolution(supported_max_slope*1.01 * 0.05, rydberg_capabilities.Δ.value_resolution)
    slope = end_value/0.05
    Δ = piecewise_linear(clocks = [0.0, 0.05, 1.0, 4.0], values = [0.0, end_value, end_value, 0.0])
    @test validate_Δ(Δ, rydberg_capabilities.Δ) == Set([
        "Δ(t) maximum value with value $end_value rad/μs exceeds maximum value of $(rydberg_capabilities.Δ.max_value) rad/μs",
        "Δ(t) maximum slope with value $slope rad/μs² exceeds maximum value of $supported_max_slope rad/μs²"
    ])

    supported_min_value = rydberg_capabilities.Δ.min_value
    Δ = piecewise_linear(clocks = [0.0, 4.0], values = [0.0, supported_min_value-0.1])
    @test validate_Δ(Δ, rydberg_capabilities.Δ) == Set([
        "Δ(t) minimum value with value $(supported_min_value-0.1) rad/μs below minimum value of $supported_min_value rad/μs"
    ])

    supported_max_value = rydberg_capabilities.Δ.max_value
    # cannot go beyond hardware supported maximum Δ value
    Δ = piecewise_linear(;clocks=[0.0,4.0], values=[0.0, supported_max_value+0.1])
    @test validate_Δ(Δ, rydberg_capabilities.Δ) == Set([
        "Δ(t) maximum value with value $(supported_max_value+0.1) rad/μs exceeds maximum value of $supported_max_value rad/μs"
    ])

    # time values must be integer multiple of resolution (0.001 μs)
    Δ = piecewise_linear(;clocks=[0.0,1.0,2.0,3.0,3.9995], values=fill(0.0,5))
    @test validate_Δ(Δ, rydberg_capabilities.Δ) == Set([
        "Δ(t) clock 3.9995 μs is not consistent with resolution 0.001 μs."
    ])

    # waveform values must be integer multiple of resolution (5.0e-7 rad)
    resolution = rydberg_capabilities.Δ.value_resolution
    value = round(11.4*resolution;sigdigits=14)
    Δ = piecewise_linear(;clocks=[0.0, 0.1, 0.2, 0.3], values=[0.0, 10*resolution, value, 0.0])
    @test validate_Δ(Δ, rydberg_capabilities.Δ) == Set([
        "Δ(t) value $value rad/μs is not consistent with resolution $resolution rad/μs."
    ])
end

@testset "validate_ϕ" begin

    rydberg_capabilities = get_rydberg_capabilities()

    # waveform duration cannot exceed maximum supported time
    ϕ = piecewise_constant(;clocks = [0.0,1.0,2.0,3.0,4.1], values = fill(0.0, 4))
    @test validate_ϕ(ϕ, rydberg_capabilities.ϕ) == Set([
        "ϕ(t) duration with value 4.1 μs exceeds maximum value of 4.0 μs"
    ])

    # waveform cannot have duration smaller than minimum allowable time step
    # can give two warnings: waveform duration is shorter than supported minimum time step
    #                        AND minimum time step is shorter than supported minimum time step
    min_time_step = rydberg_capabilities.ϕ.min_time_step
    ϕ = piecewise_constant(clocks = [0.0, min_time_step - 0.01], values = [0.0])
    @test validate_ϕ(ϕ, rydberg_capabilities.ϕ)== Set([
        "ϕ(t) duration with value $(ϕ.duration) μs below minimum value of $min_time_step μs",
        "ϕ(t) minimum step with value $(ϕ.duration) μs below minimum value of $min_time_step μs"
    ])

    # waveform minimum time step cannot be smaller than supported minimum (0.01 microseconds)
    ϕ = piecewise_constant(clocks = [0.0, 0.01, 0.011, 0.1], values=fill(0.0, 3))
    @test validate_ϕ(ϕ, rydberg_capabilities.ϕ) == Set([
        "ϕ(t) minimum step with value 0.001 μs below minimum value of $min_time_step μs"
    ])

    supported_min_value = rydberg_capabilities.ϕ.min_value
    ϕ = piecewise_constant(clocks = [0.0, 2.0, 4.0], values = [0.0, supported_min_value-0.1])
    @test validate_ϕ(ϕ, rydberg_capabilities.ϕ) == Set([
        "ϕ(t) minimum value with value $(supported_min_value-0.1) rad below minimum value of $supported_min_value rad"
    ])

    supported_max_value = rydberg_capabilities.ϕ.max_value
    # cannot go below hardware supported minimum value
    ϕ = piecewise_constant(;clocks=[0.0, 2.0,4.0], values=[0.0, supported_max_value+0.1])
    @test validate_ϕ(ϕ, rydberg_capabilities.ϕ) == Set([
        "ϕ(t) maximum value with value $(supported_max_value+0.1) rad exceeds maximum value of $supported_max_value rad"
    ])

    # initial value must be 0.0 radians
    ϕ = piecewise_constant(;clocks=[0.0,0.1,1.0,2.0], values=[0.1,0.5,0.9])
    @test validate_ϕ(ϕ, rydberg_capabilities.ϕ) == Set([
        "ϕ(t) start value with value 0.1 rad is not equal to the value of 0.0 rad"
    ])

    # time values must be integer multiple of resolution (0.001 μs)
    ϕ = piecewise_constant(;clocks=[0.0,1.0,2.0,3.0,3.9995], values=fill(0.0,4))
    @test validate_ϕ(ϕ, rydberg_capabilities.ϕ) == Set([
        "ϕ(t) clock 3.9995 μs is not consistent with resolution 0.001 μs."
    ])

    # waveform values must be integer multiple of resolution (5.0e-7 rad)
    resolution = rydberg_capabilities.ϕ.value_resolution
    value = 11.4*resolution
    ϕ = piecewise_constant(;clocks=[0.0, 0.1, 0.2, 0.3], values=[0.0, 10*resolution, value])
    @test validate_ϕ(ϕ, rydberg_capabilities.ϕ) == Set([
        "ϕ(t) value $value rad is not consistent with resolution $resolution rad."
    ])

end

@testset "check_durations" begin
    δ = Waveform(t->t,3)
    Δ = Waveform(t->t,3)
    ϕ = Waveform(t->t,3)
    Ω = Waveform(t->t,4)


    @test check_durations(ϕ,Ω,Δ,δ) == Set([
        "Ω(t) duration of 4 μs is greater than δ(t) duration of 3 μs",
        "Ω(t) duration of 4 μs is greater than Δ(t) duration of 3 μs",
        "Ω(t) duration of 4 μs is greater than ϕ(t) duration of 3 μs",
    ])
    @test check_durations(ϕ,Ω,Δ,nothing) == Set([
        "Ω(t) duration of 4 μs is greater than Δ(t) duration of 3 μs",
        "Ω(t) duration of 4 μs is greater than ϕ(t) duration of 3 μs",
    ])
    
end

@testset "validate" begin

    Ω = piecewise_linear(;clocks=Float64[0,1,2,3],values=Float64[0,1,1,0])
    Δ = piecewise_linear(;clocks=Float64[0,1,2,3],values=Float64[1,1,-1,-1])
    ϕ = piecewise_constant(;clocks=Float64[0,1,2,3],values=Float64[0,1,-1])
    atoms = 5.0 * [i for i in 1:10]
    H = rydberg_h(atoms, Ω=Ω, Δ=Δ, ϕ=ϕ)
    violations = validate(H)
    @test isempty(violations)
    
    show(stdout, MIME"text/plain"(),violations)

end

"""
    function to_braket_ahs_ir(local_value::BloqadeSchema.LocalField)

Converts `local_value` to `Braket.IR.PhysicalField`
"""
function to_braket_ahs_ir(local_value::BloqadeSchema.LocalField)

    # should also be a PhysicalField
    time_series = Braket.IR.TimeSeries(
        Dec128.(string.(local_value.values)),
        Dec128.(string.(local_value.times)),
    )

    Braket.IR.PhysicalField(
        time_series,
        Dec128.(string.(local_value.lattice_site_coefficients))
    )
end

"""
    function to_braket_ahs_ir(global_values::BloqadeSchema.GlobalField)

Converts `global_values` to `Braket.IR.PhysicalField`
"""
function to_braket_ahs_ir(global_values::BloqadeSchema.GlobalField)

    time_series = Braket.IR.TimeSeries(
        Dec128.(string.(global_values.values)),
        Dec128.(string.(global_values.times)),
    )
    # Create PhysicalField
    Braket.IR.PhysicalField(
        time_series,
        "uniform"
    )
end

"""
    function to_braket_ahs_ir(amplitude_or_phase::Union{BloqadeSchema.RabiFrequencyAmplitude,
    BloqadeSchema.RabiFrequencyPhase})
                                           
Unwraps `amplitude_or_phase` to extract their `global_value` fields which are 
immediately evaluated by `function to_braket_ahs_ir(global_values::BloqadeSchema.GlobalField)`
"""
to_braket_ahs_ir(amplitude_or_phase::Union{BloqadeSchema.RabiFrequencyAmplitude,
                                           BloqadeSchema.RabiFrequencyPhase}) = to_braket_ahs_ir(amplitude_or_phase.global_value)

"""
    function to_braket_ahs_ir(detuning::BloqadeSchema.Detuning)

Converts `detuning` to `Braket.IR.PhysicalField`'s for the `global_value`
and `local_value` fields of `detuning`. Returns the converted `global_value` first 
followed by the `local_value`. 
``
"""
function to_braket_ahs_ir(detuning::BloqadeSchema.Detuning)
    Δ = to_braket_ahs_ir(detuning.global_value)
    # local_value is Maybe{LocalField} so chance that 
    # it's `nothing` or the actual value
    δ = nothing
    if detuning.local_value !== nothing
        δ = to_braket_ahs_ir(detuning.local_value)
    end

    return Δ, δ
end

"""
    function to_braket_ahs_ir(rydberg_hamiltonian::BloqadeSchema.RydbergHamiltonian)

Converts `rydberg_hamiltonian` to `Braket.IR.Hamiltonian`
"""
function to_braket_ahs_ir(rydberg_hamiltonian::BloqadeSchema.RydbergHamiltonian)
    # PhysicalFields
    Ω = to_braket_ahs_ir(rydberg_hamiltonian.rabi_frequency_amplitude)
    ϕ = to_braket_ahs_ir(rydberg_hamiltonian.rabi_frequency_phase)
    Δ, δ = to_braket_ahs_ir(rydberg_hamiltonian.detuning)

    driving_field = [Braket.IR.DrivingField(Ω,ϕ,Δ)]
    shifting_field = Braket.IR.ShiftingField[]
    
    # check if local detuning is present
    if δ !== nothing 
        shifting_field = [Braket.IR.ShiftingField(δ)]
    end

    Braket.IR.Hamiltonian(driving_field,shifting_field)

end

"""
    function to_braket_ahs_ir(lattice::BloqadeSchema.Lattice)

Converts `lattice` to a `Braket.IR.Setup` instance.
"""
function to_braket_ahs_ir(lattice::BloqadeSchema.Lattice)
    # Convert lattice.sites to proper time for AtomArrangement, 
    # go from Vector{Tuple{Float64, Float64}} to Vector{Vector{Dec128}}
    type_converted_sites = map(collect.(lattice.sites)) do position
        map(position) do x
            Dec128(string(x))
        end
    end
    # type_converted_sites = convert(Vector{Vector{Dec128}}, collect.(lattice.sites)) 
    # create AtomArrangement for Braket IR, goes into 
    # a Setup object
    atom_arrangement = Braket.IR.AtomArrangement(
                            type_converted_sites,
                            lattice.filling
                        )
    # AtomArrangement assigned to ahs_register field
    Braket.IR.Setup(atom_arrangement)
end

"""
    function to_braket_ahs_ir(hamiltonian::BloqadeSchema.EffectiveHamiltonian)

Unwraps the `BloqadeSchema.RydbergHamiltonian` contained inside `hamiltonian`
and immediately evaluates it using
 `to_braket_ahs_ir(rydberg_hamiltonian::BloqadeSchema.RydbergHamiltonian)`
"""
to_braket_ahs_ir(hamiltonian::BloqadeSchema.EffectiveHamiltonian) = to_braket_ahs_ir(hamiltonian.rydberg::BloqadeSchema.RydbergHamiltonian)

# Public API, *THE* main function users should use
"""
   function to_braket_ahs_ir(bloqade_task::BloqadeSchema.QuEraTaskSpecification)

Converts a `bloqade_task` into a `Braket.IR.AHSProgram`
capable of being submitted to AWS Braket for execution on a QPU.

NOTE: `BloqadeSchema.QuEraTaskSpecification` contains a field `nshots` which
does not have a corresponding field in `Braket.IR.AHSProgram`. This value must be
fed as a keyword argument to a `Braket.AwsDevice` instance separately.
"""
function to_braket_ahs_ir(bloqade_task::BloqadeSchema.QuEraTaskSpecification)
    braket_schema_header = Braket.IR.braketSchemaHeader("braket.ir.ahs.program",
                                                        "1")
    setup = to_braket_ahs_ir(bloqade_task.lattice)
    hamiltonian = to_braket_ahs_ir(bloqade_task.effective_hamiltonian)

    Braket.IR.AHSProgram(braket_schema_header, setup, hamiltonian)
end

using BloqadeSchema
using Bloqade
using JSON

# Maximal Rabi frequency and maximal (and minimal) detuning to see the effect of driving off-resonantly

atoms = AtomList([(0.0, 0.0)])

T=2
Ω = constant(;duration=T, value=8π)

# maximal detuning 
Δ = constant(;duration=T, value=40π)

# minimal detuning 
# Δ = constant(;duration=T, value=-40π)

ϕ = constant(;duration=T, value=0)

h = rydberg_h(atoms;Ω=Ω, Δ=Δ, ϕ=ϕ)
h_hardware, info = hardware_transform(h)
h = to_json(h_hardware)


open("lib/BloqadeSchema/schema_examples/aws_science_tasks/global_rydberg/global3.json","w") do f
    JSON.print(f, JSON.parse(h))
end

using BloqadeSchema
using Bloqade
using JSON



# preparing 1D Z2 phase. For more details, see https://queracomputing.github.io/Bloqade.jl/dev/tutorials/2.adiabatic/main/

total_time = 3.0;
Ω_max = 2π * 4;
Ω = piecewise_linear(clocks = [0.0, 0.1, 2.1, 2.2, total_time], values = [0.0, Ω_max, Ω_max, 0, 0]);

U1 = -2π * 10;
U2 = 2π * 10;
Δ = piecewise_linear(clocks = [0.0, 0.6, 2.1, total_time], values = [U1, U1, U2, U2]);

ϕ = constant(;duration=total_time, value=0)

nsites = 9
atoms = generate_sites(ChainLattice(), nsites, scale = 5.72)


h = rydberg_h(atoms; Δ, Ω, ϕ)
h_hardware, info = hardware_transform(h)
h = to_json(h_hardware)


open("lib/BloqadeSchema/schema_examples/tutorial_examples/1D_Z2.json","w") do f
    JSON.print(f, JSON.parse(h))
end

using BloqadeSchema
using Bloqade
using JSON

# task 1
# X[pi/2] pulse, wait T, X[pi/2] pulse

atoms = AtomList([(0.0, 0.0)])

T_pi_2 = 1/16
T= 0.1

Ω = piecewise_constant(clocks = [0.0, 
                                 T_pi_2, 
                                 T + T_pi_2, 
                                 T + 2 * T_pi_2], 
                                 values = 2π * [4,0,4])
ϕ = constant(;duration = T + 2 * T_pi_2, value = 0)
Δ = constant(;duration = T + 2 * T_pi_2, value = 0)

h = rydberg_h(atoms;Ω=Ω,ϕ=ϕ,Δ=Δ)
hardware_h, info = hardware_transform(h)
h = to_json(hardware_h) 

open("lib/BloqadeSchema/schema_examples/aws_science_tasks/global_rydberg/global5.json","w") do f
    JSON.print(f, JSON.parse(h))
end



# task 2
# X[pi/2] pulse, wait T, Y[pi/2] pulse

atoms = AtomList([(0.0, 0.0)])

T_pi_2 = 1/16
T= 0.1

Ω = piecewise_constant(clocks = [0.0, T_pi_2, T + T_pi_2, T + 2 * T_pi_2], values = 2π * [4,0,4] )
ϕ = piecewise_constant(clocks = [0.0, T_pi_2, T + T_pi_2, T + 2 * T_pi_2], values =  [0.0,0.0,π/2] )
Δ = constant(;duration = T + 2 * T_pi_2, value = 0)

h = rydberg_h(atoms;Ω=Ω,ϕ=ϕ,Δ=Δ)
hardware_h, info = hardware_transform(h)
h = to_json(hardware_h) 


open("lib/BloqadeSchema/schema_examples/aws_science_tasks/global_rydberg/global5.json","w") do f
    JSON.print(f, JSON.parse(h))
end

# task 3
# X[pi/2] pulse, wait T/2, X[pi] pulse, wait T/2, X[pi/2] pulse

atoms = AtomList([(0.0, 0.0)])

T_pi_2 = 1/16
T= 0.1

Ω = piecewise_constant(clocks=[0.0, 
                               T_pi_2,
                               T/2 + T_pi_2, 
                               T/2 + 3*T_pi_2, 
                               T + 3*T_pi_2,
                               T + 4*T_pi_2], 
                               values = 2π * [4, 0, 4, 0, 4])
ϕ = constant(;duration=T+4*T_pi_2, value = 0)
Δ = constant(;duration=T+4*T_pi_2, value = 0)

h = rydberg_h(atoms;Ω=Ω,ϕ=ϕ,Δ=Δ)
h_hardware, info = hardware_transform(h)
h = to_json(h_hardware)


open("lib/BloqadeSchema/schema_examples/aws_science_tasks/global_rydberg/global5.json","w") do f
    JSON.print(f, JSON.parse(h))
end

using Test
using Configurations
using BloqadeSchema

task = QuEraTaskSpecification(;
    nshots = 239,
    lattice = BloqadeSchema.Lattice(; sites = [(0, 0), (5, 0), (0, 5), (5, 5)], filling = [1, 0, 1, 0]),
    effective_hamiltonian = BloqadeSchema.EffectiveHamiltonian(;
        rydberg = BloqadeSchema.RydbergHamiltonian(;
            rabi_frequency_amplitude = BloqadeSchema.RabiFrequencyAmplitude(;
                global_value = BloqadeSchema.GlobalField(;
                    times = [0, 5, 10],
                    values = [3, 4, 5],
                ),
            ),
            rabi_frequency_phase = BloqadeSchema.RabiFrequencyPhase(;
                global_value = BloqadeSchema.RabiFrequencyPhaseGlobal(; times = [0, 3, 6], values = [5, 4, 3]),
            ),
            detuning = BloqadeSchema.Detuning(;
                global_value = BloqadeSchema.GlobalField(; times = [0, 2, 4], values = [3, 4, 5]),
                local_value = [
                    BloqadeSchema.LocalField(;
                        times = [1, 3, 5],
                        values = [5, 4, 3],
                        lattice_site_coefficients = [1, 0, 1, 0],
                    ),
                    BloqadeSchema.LocalField(;
                        times = [5, 6, 7],
                        values = [3, 2, 1],
                        lattice_site_coefficients = [1, 1, 1, 1],
                    ),
                ],
            ),
        ),
    ),
)

to_dict(task)["effective_hamiltonian"]["rydberg"]["detuning"]["local"]
# to_toml("test.toml", task)
# from_toml(QuEraTaskSpecification, pkgdir(BloqadeSchema, "test", "test.toml"))

using Test
using BloqadeWaveforms
using BloqadeExpr
using BloqadeSchema
using JSON
using Configurations
using Unitful: μs, s, MHz, rad 
using Logging


@testset "ViolationException" begin
    
    Ω = piecewise_linear(;clocks=Float64[0,1,2,3],values=Float64[0,1,1,0])
    Δ = piecewise_linear(;clocks=Float64[0,1,2,3],values=Float64[1,1,-1,-1])
    ϕ = piecewise_constant(;clocks=Float64[0,1,2,4],values=Float64[0,1,-1])
    atoms = 5.0 * [i for i in 1:10]
    h = rydberg_h(atoms, Ω=Ω, Δ=Δ, ϕ=ϕ)
    @test_throws BloqadeSchema.ValidationException to_json(h)

end

@testset "convert_units" begin
    T = 1 # seconds
    T_list = [i for i in 1:10]
    pair = (1,2)
    pair_list = [(i,j) for i in 1:5 for j in 1:5]
    @test 1e6 ≈ BloqadeSchema.convert_units(T,s,μs)
    @test (1e6 .* T_list) ≈ BloqadeSchema.convert_units(T_list,s,μs)
    @test all((1e6 .* pair ).≈ BloqadeSchema.convert_units.(pair,s,μs))

end

@testset "to_schema"  begin
    
    T = 0.5
    atoms = [(5*i,0) for i in 1:10]

    # values = [1.0,nothing,Waveform(t->sin(2π*t/T)^2,T/2)]

    wf1 = Waveform(t->sin(π*t/T)^2,T)
    wf2 = Waveform(t->cos(π*t/T),T)
    wfs_mixed = [(i%2==0 ? 1 : 0.1)*wf1 + wf2 for i in 1:length(atoms)]
    wfs_same = [i*wf1+wf2 for i in 1:length(atoms)]
    scalar_values = [constant(;duration=T,value=1.0),wf1,wf2]
    # all_values = [constant(;duration=T,value=1.0),wf1,wfs_mixed,wfs_same]
    params = get_device_capabilities_SI()

    check_atom_res(x) = !any(BloqadeSchema.check_resolution.(params.lattice.geometry.position_resolution,x))
    check_clock_res(x) = !any(BloqadeSchema.check_resolution.(params.rydberg.global_value.time_resolution,x))
    check_Δ_res(x) = !any(BloqadeSchema.check_resolution.(params.rydberg.global_value.detuning_resolution,x))
    # check_δ_res(x) = !any(BloqadeSchema.check_resolution.(params.rydberg.local_value.common_detuning_resolution,x))
    # check_Δi_res(x) = !any(BloqadeSchema.check_resolution.(params.rydberg.local_value.local_detuning_resolution,x))
    check_ϕ_res(x) = !any(BloqadeSchema.check_resolution.(params.rydberg.global_value.phase_resolution,x))
    check_Ω_res(x) = !any(BloqadeSchema.check_resolution.(params.rydberg.global_value.rabi_frequency_resolution,x))

    for Ω in scalar_values, ϕ in scalar_values, Δ in scalar_values
        h = rydberg_h(atoms;Ω=Ω,Δ=Δ,ϕ=ϕ)
        h_hw,info = hardware_transform(h)
        j = BloqadeSchema.to_json(h_hw)

        t = Configurations.from_dict(BloqadeSchema.QuEraTaskSpecification, JSON.parse(j))

        sites = [site for (i,site) in enumerate(t.lattice.sites) if t.lattice.filling[i] == 1]
        
        rabi_freq_amp = t.effective_hamiltonian.rydberg.rabi_frequency_amplitude.global_value
        rabi_freq_phase = t.effective_hamiltonian.rydberg.rabi_frequency_phase.global_value
        detuning_global = t.effective_hamiltonian.rydberg.detuning.global_value
        detuning_local = t.effective_hamiltonian.rydberg.detuning.local_value

        pos_res = params.lattice.geometry.position_resolution
        @test all(check_atom_res(s) for s in sites)
        @test check_clock_res(rabi_freq_phase.times)
        @test check_clock_res(rabi_freq_amp.times)
        @test check_clock_res(detuning_global.times)
        @test check_ϕ_res(rabi_freq_phase.values)
        @test check_Ω_res(rabi_freq_amp.values)
        @test check_Δ_res(detuning_global.values)

        if !isnothing(detuning_local)
            @test check_clock_res(detuning_local.times)
            @test check_δ_res(detuning_local.values)
            @test check_Δi_res(detuning_local.lattice_site_coefficients)                  
        end
    end

end


@testset "execute" begin
    # Test if code will run without failing
    Ω = piecewise_linear(;clocks=Float64[0,1,2,3],values=Float64[0,1,1,0])
    Δ = piecewise_linear(;clocks=Float64[0,1,2,3],values=Float64[1,1,-1,-1])
    ϕ = constant(;duration=3,value=0)
    atoms = 5.0 * [i for i in 1:10]
    
    h = rydberg_h(atoms,Ω=Ω,Δ=Δ,ϕ=ϕ)
    h,info = hardware_transform(h)
    task_string = to_json(h;n_shots=10)
    task_dict = BloqadeSchema.to_dict(h;n_shots=10)
    task = BloqadeSchema.to_schema(h;n_shots=10)
    
    @test execute(task_string) isa String
    @test execute(task_dict) isa String
    @test execute(task) isa String

end


@testset "conversion to and from schema" begin
        # Test if code will run without failing
        Ω = piecewise_linear(;clocks=Float64[0,1,2,3],values=Float64[0,1,1,0])
        Δ = piecewise_linear(;clocks=Float64[0,1,2,3],values=Float64[1,1,-1,-1])
        ϕ = constant(;duration=3,value=0)
        atoms = [(5.0*i,0.0) for i in 1:4]
        
        h = rydberg_h(atoms,Ω=Ω,Δ=Δ,ϕ=ϕ)
        h,info = hardware_transform(h)
        @test h == BloqadeSchema.from_schema(BloqadeSchema.to_schema(h))
        @test h == BloqadeSchema.from_dict(BloqadeSchema.to_dict(h))
        @test h == BloqadeSchema.from_json(BloqadeSchema.to_json(h))
end


@testset "to_json_no_validation" begin
    # Test if code will run without failing
    Ω = piecewise_linear(;clocks=Float64[0,1,2,3],values=Float64[0,1,1,0])
    Δ = piecewise_linear(;clocks=Float64[0,1,2,3],values=Float64[1,1,-1,-1])
    ϕ = piecewise_constant(;clocks=Float64[0,1,2,3],values=Float64[1,1,-1])
    atoms = [(5.0*i,0.0) for i in 1:4]
    
    h = rydberg_h(atoms,Ω=Ω,Δ=Δ,ϕ=ϕ)
    h,info = hardware_transform(h)    
     atoms,ϕ,Ω,Δ = get_rydberg_params(h)

    @test to_json_no_validation(atoms,ϕ=ϕ,Ω=Ω,Δ=Δ) == to_json(h)
    @test to_schema_no_validation(atoms,ϕ=ϕ,Ω=Ω,Δ=Δ) == to_schema(h)

    # test with partial filling
    coords = [(5.0*i,0.0) for i in 1:4]
    filling = [0,1,1,0]

    lattice = BloqadeSchema.Lattice(sites=atoms,filling=filling)

    @test to_json_no_validation(lattice,ϕ=ϕ,Ω=Ω,Δ=Δ) == "{\"nshots\":1,\"lattice\":{\"sites\":[[5.0e-6,0.0],[1.0e-5,0.0],[1.5e-5,0.0],[2.0e-5,0.0]],\"filling\":[0,1,1,0]},\"effective_hamiltonian\":{\"rydberg\":{\"rabi_frequency_amplitude\":{\"global\":{\"times\":[0.0,1.0e-6,2.0e-6,3.0e-6],\"values\":[0.0,1.0e6,1.0e6,0.0]}},\"rabi_frequency_phase\":{\"global\":{\"times\":[0.0,1.0e-6,2.0e-6,3.0e-6],\"values\":[0.0,1.0,-1.0,-1.0]}},\"detuning\":{\"global\":{\"times\":[0.0,1.0e-6,2.0e-6,3.0e-6],\"values\":[1.0e6,1.0e6,-1.0e6,-1.0e6]}}}}}"
end   

@testset "nshots validation" begin
    Ω = piecewise_linear(;clocks=Float64[0,1,2,3],values=Float64[0,1,1,0])
    Δ = piecewise_linear(;clocks=Float64[0,1,2,3],values=Float64[1,1,-1,-1])
    ϕ = constant(;duration=3,value=0)
    atoms = [(5.0*i,0.0) for i in 1:4]
    
    h = rydberg_h(atoms,Ω=Ω,Δ=Δ,ϕ=ϕ)
    h,info = hardware_transform(h)

    dc = get_device_capabilities()

    @test_throws BloqadeSchema.ValidationException to_json(h;n_shots=dc.task.number_shots_min-1)
    @test_throws BloqadeSchema.ValidationException to_json(h;n_shots=dc.task.number_shots_max+1)

end

using BloqadeSchema
using Bloqade
using JSON


# No detuning, and constant rabi_frequency pulse applied at max strength for a short period of time (to achieve a quick pi-pulse)


atoms = AtomList([(0.0, 0.0)])

T=1/8

Ω = constant(;duration=T,value=8π)
ϕ = constant(;duration=T,value=0)
Δ = constant(;duration=T,value=0)

h = rydberg_h(atoms;Ω=Ω,ϕ=ϕ,Δ=Δ)
h_hardware,info = hardware_transform(h)
h = to_json(h_hardware)


open("lib/BloqadeSchema/schema_examples/aws_science_tasks/global_rydberg/global1.json","w") do f
    JSON.print(f, JSON.parse(h))
end

using BloqadeSchema
using Test

function has_docstring(obj, sig::Type = Union{})
    Docs.getdoc(obj, sig) === nothing || return true
    binding = Docs.Binding(parentmodule(obj), nameof(obj))
    for mod in Docs.modules
        dict = Docs.meta(mod)
        haskey(dict, binding) || continue
        multidoc = dict[binding]
        for msig in multidoc.order
            sig <: msig && return true
        end
    end
    return false
end



@testset "Docstring Present" begin
    for symbol in names(BloqadeSchema)

        obj = Base.eval(@__MODULE__, :(BloqadeSchema.$symbol))

        typeof(obj) <: Union{Module} && continue
        
        @testset "$symbol" begin
            @test has_docstring(obj)
        end
    end
end

schema_parse_pwl_field(::Symbol,field::PiecewiseLinearWaveform) = field
schema_parse_pwl_field(name::Symbol,::Any) = error("Cannot convert Hamiltonian to schema, $name must be piecewise linear Waveform.")

schema_parse_pwc_field(::Symbol,field::PiecewiseConstantWaveform) = field
schema_parse_pwc_field(name::Symbol,::Any) = error("Cannot convert Hamiltonian to schema, $name must be piecewise constant Waveform.")



#= 
schema_parse_ϕ(ϕ::Waveform{BloqadeWaveforms.PiecewiseLinear{T,I},T}) where {T<:Real,I} = ϕ
schema_parse_Ω(Ω::Waveform{BloqadeWaveforms.PiecewiseLinear{T,I},T}) where {T<:Real,I} = Ω

schema_parse_ϕ(_) = error("Cannot convert Hamiltonian to schema, ϕ(t) must be piecewise linear Waveform.")
schema_parse_Ω(_) = error("Cannot convert Hamiltonian to schema, Ω(t) must be piecewise linear Waveform.")

function schema_parse_Δ(Δ)
    Δ isa PiecewiseLinearWaveform  && return (Δ,nothing,1.0)
    
    if Δ isa Vector

        map(Δ) do ele
            ele isa PiecewiseLinearWaveform || error("Cannot convert Hamiltonian to schema, Δ(t) must be a single or collection of piecewise linear Waveform(s).")
        end

        clocks = Δ[1].f.clocks
        map(Δ) do ele
            clocks == ele.f.clocks || error("Cannot convert Hamiltonian to schema, all piecewise linear Waveform(s) must have same clocks.")
        end

        Δti = zeros(length(clocks),length(Δ))
    
        for (j,δ) in enumerate(Δ)
            Δti[:,j] .= δ.f.values # copy values to Δti
        end
        
        ((δ_values,Δi),(Δ_values,_)) = find_local_masks(Δti;name=:Δ,assert_truncation=true)
        
        δ_values = round.(δ_values;sigdigits=13)
        Δ_values = round.(Δ_values;sigdigits=13)
        Δi = round.(Δi;sigdigits=14)
        
        
        # get waveforms
        Δ = piecewise_linear(;
            clocks = clocks,
            values = Δ_values
        )

        δ = piecewise_linear(;
            clocks = clocks,
            values = δ_values
        )

        return (Δ,δ,Δi)
    else
        error("Cannot convert Hamiltonian to schema, Δ(t) must be a single or collection of piecewise linear Waveform(s).")
    end
end
=#

# pass fail function. 
# certain criteria is required to pass
# 1. all waveforms must be PWL
# 2. Local detuning must be PWL with all same clocks and can be decomposed 
#    the waveform is Δ(i,t) = Δ(t) + Δ_i * δ(t)
function schema_parse_rydberg_fields(h::BloqadeExpr.RydbergHamiltonian)
    atoms,ϕ,Ω,Δ = get_rydberg_params(h)
    ϕ = schema_parse_pwc_field(:ϕ,ϕ) # PWL => PWC for checks
    Ω = schema_parse_pwl_field(:Ω,Ω) 
    Δ = schema_parse_pwl_field(:Δ,Δ)
    return (atoms,ϕ,Ω,Δ,nothing,1.0)
end
    

using GarishPrint
using JSON

const PiecewiseLinearWaveform = Waveform{BloqadeWaveforms.PiecewiseLinear{T,I},T} where {T<:Real,I}
const PiecewiseConstantWaveform = Waveform{BloqadeWaveforms.PiecewiseConstant{T},T} where {T<:Real}

"""
    struct SchemaTranslationParams

Used to specify number of times a Hamiltonian should be executed and the capabilities of the machine the Hamiltonian
will be executed on as an argument to functions that convert Hamiltonians to other formats.

See also [`to_schema`](@ref), [`to_dict`](@ref), [`to_json`](@ref)

# Fields
- `nshots::Int = 1`:  The number of times a Hamiltonian should be executed
- `device_capabilities::DeviceCapabilities = get_device_capabilities()`: capabilities of the machine the Hamiltonian will be executed on
"""
@option struct SchemaTranslationParams <: QuEraSchema
    n_shots::Int = 1
    device_capabilities::DeviceCapabilities = get_device_capabilities()
end

"""
    struct HardwareTransformInfo <: QuEraSchema

Contains the calculated differences (error) betwen the original and transformed waveforms and atoms from
invoking [`hardware_transform`](@ref) on a [`BloqadeExpr.RydbergHamiltonian`](@ref).

# Fields
- `ϕ_error`: Error between the original laser phase waveform (``A``) and transformed one (``B``) waveforms calculated as ``\\Vert A - B\\Vert_1``. 
- `Ω_error`: Error between the original Rabi frequency waveform (``A``) and transformed one (``B``) waveforms calculated as ``\\Vert A - B\\Vert_1``.
- `Δ_error`: Error between the global detuning waveform (``A``) and transformed one (``B``) waveforms calculated as ``\\Vert A - B\\Vert_1``.
- `Δ_mask`: Decoupling of local detuning field inferred from the detuning value specified in Δ.
!!! note "Local Detuning Support"
    Local Detunings are currently not supported by Bloqade but will be in future releases.
- `mse_atoms`: Mean Squared Error between original atom positions and transformed ones.

"""
@Base.kwdef struct HardwareTransformInfo <: QuEraSchema
    ϕ_error
    Ω_error
    Δ_error
    Δ_mask
    mse_atoms
end


@option struct ShotOutput <: QuEraSchema
    shot_status_code::Int32
    pre_sequence::Vector{Int32}
    post_sequence::Vector{Int32}
end

"""
    struct TaskOutput <: QuEraSchema

The result of executing a `QuEraTaskSpecification` on the machine.

Output of [`execute`](@ref) function.

# Fields
- `task_status_code::Int`: Task Status
- `shot_outputs::Vector{ShotOutput}`: Contains pre- and post- shot 
sequence in binary of if atoms are in Rydberg/Ground state.
"""
@option struct TaskOutput <: QuEraSchema
    task_status_code::Int
    shot_outputs::Vector{ShotOutput}
end

"""
    struct ValidationViolations <: QuEraSchema

Stores violations of hardware constraints from the user-supplied
[`BloqadeExpr.RydbergHamiltonian`](@ref) as strings in sets.
This is returned by [`validate`](@ref) and [`to_schema`](@ref).

# Fields
- `lattice_violations::Set`: violations of hardware-supported lattice geometry
- `misc_violations::Set`: violations that do not fall into other categories (e.g. number of shots)
- `Δ_violations::Set`: violations of detuning waveform
- `Ω_violations::Set`: violations of Rabi frequency waveform
- `ϕ_violations::Set`: violations of Phase waveform
- `δ_violations::Set`: violations of local detuning waveforms
"""
Base.@kwdef struct ValidationViolations <: QuEraSchema
    lattice_violations::Set
    misc_violations::Set
    Δ_violations::Set
    Ω_violations::Set
    ϕ_violations::Set
    δ_violations::Set
end

struct ValidationException <: Exception 
    violations::ValidationViolations
end

Base.isempty(t::ValidationViolations) = (
        isempty(t.lattice_violations) && 
        isempty(t.misc_violations)    && 
        isempty(t.Δ_violations)       && 
        isempty(t.Ω_violations)       && 
        isempty(t.ϕ_violations)       && 
        isempty(t.δ_violations)
    )



function Base.show(io::IO, ::MIME"text/plain", t::ValidationViolations)
    violations_list = [
        t.lattice_violations, 
        t.misc_violations,
        t.ϕ_violations, 
        t.Ω_violations,
        t.Δ_violations, 
        t.δ_violations
    ]
    println(io,"The following validation violations occured:\n")
    nviolation = one(Int)
    foreach(violations_list) do violations
        for msg in violations
            println(io,nviolation,". ",msg)
            nviolation+=1
        end
    end
end

function Base.show(io::IO, ::MIME"text/plain", t::QuEraTaskSpecification)
    GarishPrint.pprint_struct(io, t)
end

function Base.show(io::IO, ::MIME"text/plain", t::TaskOutput)
    GarishPrint.pprint_struct(io, t)
end

function Base.showerror(io::IO, e::ValidationException)
    show(io,MIME"text/plain"(),e.violations)
end

using Unitful:
    μm,
    m,
    rad,
    s,
    @u_str
using BloqadeSchema:
    BloqadeSchema,
    parse_unit,
    convert_units_recursive,
    get_device_capabilities,
    get_device_capabilities_SI
using Test

@testset "parse_units" begin
    tests = [
        ("m",:(m)),
        ("s",:(s)),
        ("m/s",:(m/s)),
        ("m*s^2",:(m*s^2))
    ]
    for (str,expr) in tests
        str_val =  Base.eval(@__MODULE__,parse_unit(@__MODULE__, str))
        expr_val = Base.eval(@__MODULE__,expr)
        @test str_val ===expr_val
    end



end

@testset "convert_units_recursive" begin

    @testset "base units" begin
    # main units that are targeted for conversion, 
    # m should become μm
    # s should become μs

    # create one dictionary for units
    unit_dict = Dict(
        "a" => "m",
        "b" => "s"
    )
    # another dictionary with the actual values
    value_dict = Dict(
        "a" => 2.0,
        "b" => 5.1
    )

    # expected results
    expected_dict = Dict(
        "a" => 2.0e6,
        "b" => 5.1e6
    )

    @test convert_units_recursive(value_dict, unit_dict) == expected_dict
    end
    
    @testset "compound units" begin
    # Test compound units, 
    # rad/s should become rad/μs
    # rad/s^2 should become rad/μs^2
    # rad*m^6/s should become rad*um^6 / μs
    unit_dict = Dict(
        "a" => "rad/s",
        "b" => "rad/s^2",
        "c" => "rad*m^6/s"
    )

    value_dict = Dict(
        "a" => 1.58E7,
        "b" => 2.5E14,
        "c" => 5.42E-24,
    )

    expected_dict = Dict(
        "a" => 15.8,
        "b" => 2.5e2,
        "c" => 5.42e6
    )

    @test convert_units_recursive(value_dict, unit_dict) == expected_dict
    end

    @testset "mixed units" begin
        # units that should be converted should be converted,
        # units that shouldn't be are left alone
        unit_dict = Dict(
            "a" => "rad",
            "b" => "s",
            "c" => "m"
        )

        value_dict = Dict(
            "a" => 5.0E-7,
            "b" => 1.0E-9,
            "c" => 4.0E-6
        )

        expected_dict = Dict(
            "a" => 5.0e-7,
            "b" => 1.0e-3,
            "c" => 4.0
        )

        @test convert_units_recursive(value_dict, unit_dict) == expected_dict
    end

    @testset "no units" begin
        # anything specified with NoUnits should be left alone
        unit_dict = Dict(
            "a" => "NoUnits",
            "b" => "NoUnits",
            "c" => "NoUnits"
        )

        value_dict = Dict(
            "a" => 100,
            "b" => 1000,
            "c" => 100
        )

        @test convert_units_recursive(value_dict, unit_dict) == value_dict
    end

    @testset "nested_dictionary" begin
        # should be able to handle dictionaries inside dictionaries
        unit_dict = Dict(
            "a" => Dict(
                "a1" => "NoUnits",
                "a2" => "NoUnits",
                "a3" => Dict(
                    "a3.1" => "rad/s",
                    "a3.2" => "rad/s"
                )
            ),
            "b" => "rad*m^6/s",
            "c" => Dict(
                "c1" => "rad/s^2",
                "c2" => Dict(
                    "c2.1" => "s",
                    "c2.2" => "m"
                )
            )
        )

        value_dict = Dict(
            "a" => Dict(
                "a1" => 1,
                "a2" => 100,
                "a3" => Dict(
                    "a3.1" => 0.0,
                    "a3.2" => 1.58E7
                )
            ),
            "b" => 6.21E-24,
            "c" => Dict(
                "c1" => 3.1E15,
                "c2" => Dict(
                    "c2.1" => 1.0E-9,
                    "c2.2" => 7.5E-5
                )
            )
        )

        expected_dict = Dict(
            "a" => Dict(
                "a1" => 1,
                "a2" => 100,
                "a3" => Dict(
                    "a3.1" => 0.0,
                    "a3.2" => 15.8 
                )
            ),
            "b" => 6.21e6,
            "c" => Dict(
                "c1" => 3.1e3,
                "c2" => Dict(
                    "c2.1" => 1.0e-3,
                    "c2.2" => 75
                )
            )
        )

        @test convert_units_recursive(value_dict, unit_dict) == expected_dict
    end 
end


@testset "get_device_capabilities" begin

    @test typeof(get_device_capabilities()) === BloqadeSchema.DeviceCapabilities 
    @test typeof(get_device_capabilities_SI()) === BloqadeSchema.DeviceCapabilities

end

using BloqadeSchema
using BloqadeExpr
using Configurations
using Test
using BloqadeSchema
using BloqadeWaveforms
using Logging

@testset "set_resolution" begin

    examples = [
        (1,10.123,10.0),
        (0.1,10.1256,10.1),
        (0.01,10.1256,10.13),
    ]
    for (δ,val,res) in examples
        @test BloqadeSchema.set_resolution(val,δ) == res
    end

end

@testset "norm_diff_durations" begin
    A = constant(;duration=2,value=1)
    for x in [0.1,1,1.5]
        B = constant(;duration=x,value=1)
        @test 2-x ≈ BloqadeSchema.norm_diff_durations(A,B)
        @test 2-x ≈ BloqadeSchema.norm_diff_durations(B,A)
    end
end


# test for all warning and error functions
@testset "warning and errors" begin
    for value in [nothing,1.0,rand(10),t->t^2]
        @test_throws ErrorException BloqadeSchema.check_waveform(value,:test)
    end
    
    wf = Waveform(t->t^2,π)
    wfs = [i*wf for i in rand(10)]

    @test_throws ErrorException BloqadeSchema.check_global(wfs,:test)

    time_res = 1.0e-3

    test_logger = Test.TestLogger(;min_level=Logging.Debug);
    with_logger(test_logger) do
        BloqadeSchema.warn_duration(time_res,wf,:test)
        BloqadeSchema.warn_duration(time_res,wfs,:test)
    end
    @test test_logger.logs[1].message == "waveform test duration will be rounded during hardware transformation."
    @test test_logger.logs[2].message == "waveform test duration will be rounded during hardware transformation."

end



@testset "pin_waveform_edges" begin
    wf = constant(;duration=1.0,value=1.0)
    max_slope = 10
    begin_value = 0.0
    end_value = 0.0
    target_wf = piecewise_linear(;clocks=[0.0,0.1,0.9,1],values=[0.0,1.0,1.0,0.0])
    new_wf =  BloqadeSchema.pin_waveform_edges(wf,:wf,max_slope,begin_value,end_value)
    
    # removing this until issue with append is fixed. 
    @test new_wf ≈ target_wf

    wf = Waveform(t->1+t^2,1)
    max_slope = 100
    begin_value = 0.5
    end_value = 1.0
    # missing first and last values
    test_logger = Test.TestLogger(;min_level=Logging.Debug);
    new_wf = with_logger(test_logger) do
        BloqadeSchema.pin_waveform_edges(wf,:wf,max_slope,begin_value,end_value)
    end
    @test test_logger.logs[1].message == "During hardware transform: wf(t) initial value is not $begin_value. adding ramp to fix endpoints."
    @test test_logger.logs[2].message == "During hardware transform: wf(t) end value is not $end_value. adding ramp to fix endpoints."
    @test new_wf(0.0) == begin_value
    @test new_wf(1.0) == end_value

    wf = Waveform(t->t^2,1)
    max_slope = 100
    begin_value = 0.0
    end_value = 0.0
    test_logger = Test.TestLogger(;min_level=Logging.Debug);
    new_wf = with_logger(test_logger) do
        BloqadeSchema.pin_waveform_edges(wf,:wf,max_slope,begin_value,end_value)
    end
    @test test_logger.logs[1].message == "During hardware transform: wf(t) end value is not $end_value. adding ramp to fix endpoints."
    @test new_wf(0.0) == begin_value
    @test new_wf(1.0) == end_value

    
    wf = Waveform(t->1-t^2,1)
    max_slope = 100
    begin_value = 0.0
    end_value = 0.0
    test_logger = Test.TestLogger(;min_level=Logging.Debug);
    new_wf = with_logger(test_logger) do
        BloqadeSchema.pin_waveform_edges(wf,:wf,max_slope,begin_value,end_value)
    end
    @test test_logger.logs[1].message == "During hardware transform: wf(t) initial value is not $begin_value. adding ramp to fix endpoints."
    @test new_wf(0.0) == begin_value
    @test new_wf(1.0) == end_value

end


@testset "clip_waveform" begin
    wflist = [
            piecewise_linear(;clocks=[0,1,2,3,4,5,6],values=[0,2,2,0,-2,-2,0]),
            piecewise_constant(;clocks=[0,1,2,3,4,5,6],values=[0,2,2,0,-2,-2])
        ]
    wflist_clipped = [
            piecewise_linear(;clocks=[0,1,2,3,4,5,6],values=[0,1,1,0,-1,-1,0]),
            piecewise_constant(;clocks=[0,1,2,3,4,5,6],values=[0,1,1,0,-1,-1])
        ]
    for (wf,wf_clipped) in zip(wflist,wflist_clipped)
        @test BloqadeSchema.clip_waveform(wf,:wf,-1,1) == wf_clipped

        test_logger = Test.TestLogger(;min_level=Logging.Debug);
        with_logger(test_logger) do
            BloqadeSchema.clip_waveform(wf,:wf,-1,1)
        end
        
        @test test_logger.logs[1].message == "During hardware transform: wf(t) falls outside of hardware bounds, clipping to maximum/minimum."
    end
end



@testset "hardware_transform_ϕ" begin
    device_capabilities = get_device_capabilities()

    wf = Waveform(t->1+t^2,1)
    wf_1,error_1 = BloqadeSchema.hardware_transform_ϕ(wf,device_capabilities)
    wf_2,error_2 = BloqadeSchema.hardware_transform_ϕ(wf_1,device_capabilities)

    @test wf_1 == wf_2
    @test error_2 == 0
end

@testset "hardware_transform_Ω" begin
    device_capabilities = get_device_capabilities()

    wf = Waveform(t->1+t^2,1)
    new_wf,error = BloqadeSchema.hardware_transform_Ω(wf,device_capabilities)
    @test new_wf(0.0) == 0
    @test new_wf(1.0) == 0

    wf = Waveform(t->t^2,1)
    new_wf,error = BloqadeSchema.hardware_transform_Ω(wf,device_capabilities)
    @test new_wf(0.0) == 0
    @test new_wf(1.0) == 0

    
    wf = Waveform(t->1-t^2,1)
    new_wf,error = BloqadeSchema.hardware_transform_Ω(wf,device_capabilities)
    @test new_wf(0.0) == 0
    @test new_wf(1.0) == 0
end

# local test case
# for piecewise linear waveforms Δ and δ, Δi that satisfy resolution 
# conditions check that this function can return a waveform that passes '≈' test. 
@testset "hardware_transform_Δ" begin
    device_capabilities = get_device_capabilities()

    wf = Waveform(t->1+t^2,1)
    wf_1,error_1 = BloqadeSchema.hardware_transform_Δ(wf,device_capabilities)
    wf_2,error_2 = BloqadeSchema.hardware_transform_Δ(wf_1,device_capabilities)

    @test wf_1 == wf_2
    @test error_2 == 0
end


@testset "hardware_transform_parse" begin

    atoms = [(1.14,4.0),(2.2,1),(5,3.37),(10,5.35)]
    dc = get_device_capabilities()
    Δ = piecewise_linear(;clocks=[0.0,1.0,2.0,3.0],values=[1.0,0.0,0.0,-1.0])
    Ω = piecewise_linear(;clocks=[0.0,1.0,2.0,3.0],values=[0.0,1.0,1.0,0.0])
    ϕ = piecewise_constant(;clocks=[0.0,1.0,2.0,3.0],values=[0.0,1,-1])
    H = rydberg_h(atoms,Δ=Δ,ϕ=ϕ,Ω=Ω)

    Δ_mask = (Δ=Δ,δ=nothing,Δi=1.0)

    (new_atoms,new_ϕ,new_Ω,new_Δ,info) = BloqadeSchema.hardware_transform_parse(H,dc)

    mse_atoms = (0.04+0.0+0.03+0.05)/4.0

    @test new_atoms == [(1.1,4.0),(2.2,1.0),(5.0,3.4),(10.0,5.3)]
    @test Δ == new_Δ
    @test Ω == new_Ω
    @test ϕ == new_ϕ
    @test info.Δ_error == 0
    @test info.Ω_error == 0
    @test info.ϕ_error == 0
    @test info.mse_atoms ≈ mse_atoms # up to rouding errors
    @test info.Δ_mask == Δ_mask

end

function parse_unit(curr::Module, unit::AbstractString)
    ex = Meta.parse(unit)
    unitmods = [Unitful]
    for m in Unitful.unitmodules
        # Find registered unit extension modules which are also loaded by
        # __module__ (required so that precompilation will work).
        if isdefined(curr, nameof(m)) && getfield(curr, nameof(m)) === m
            push!(unitmods, m)
        end
    end
    return Unitful.lookup_units(unitmods, ex)
end

function convert_units_recursive(input_value,units)

    if typeof(input_value) <: AbstractDict
        # make a copy
        new_values = Dict(input_value)
        # for each k,v in input_dict, 
        # find the unit in the units dict and convert v to that unit
        for (key,value) in input_value
            new_values[key] = convert_units_recursive(value,units[key])
        end
        return new_values
    else
        units == "NoUnits" && return input_value
        
        # Inside the units dictionary, 
        # replace instances of μm with m, 
        # THEN replace instances of s with μs
        to_units = replace(
                replace(units,
                "m"=>"μm"),
            "s"=>"μs")

        from = Base.eval(@__MODULE__,parse_unit(@__MODULE__,units))
        to   = Base.eval(@__MODULE__,parse_unit(@__MODULE__,to_units))

        return convert_units(input_value,from,to)
    end
end

"""
    get_device_capabilities(capabilities_file=nothing)

Generates a `DeviceCapabilities` struct from either an explicitly provided path to a capabilities
JSON file or using the default JSON provided in "lib/BloqadeSchema/config/capabilities-qpu1-mock.json".

By default, the units for capabilities JSON file are specified by the 
"lib/BloqadeSchema/config/capabilities-qpu1-mock-units.json" file this function
gives a `DeviceCapabilities` struct with *non-SI base* (e.g. μm, μs) units.

See also [`get_device_capabilities_SI`](@ref)

```jldoctest; 
julia> get_device_capabilities()
BloqadeSchema.DeviceCapabilities(BloqadeSchema.TaskCapabilities(1, 1000), BloqadeSchema.LatticeCapabilities(BloqadeSchema.LatticeAreaCapabilities(75.0, 76.0), BloqadeSchema.LatticeGeometryCapabilities(4.0, 4.0, 0.1, 256), 256), BloqadeSchema.RydbergCapabilities(5.42e6, BloqadeSchema.RydbergGlobalCapabilities(0.0, 15.8, 0.0004, 250.0, -125.0, 125.0, 2.0e-7, 2500.0, -99.0, 99.0, 5.0e-7, 0.0, 4.0, 0.001, 0.05), nothing))
```
"""
function get_device_capabilities(capabilities_file=nothing)
    units_file = joinpath(pkgdir(@__MODULE__),"config","capabilities-qpu1-mock-units.json")
    capabilities_json_units = JSON.parse(JSON.open(units_file))["capabilities"]

    capabilities_json_SI = if isnothing(capabilities_file)
        capabilities_file = joinpath(pkgdir(@__MODULE__),"config","capabilities-qpu1-mock.json")
        JSON.parse(JSON.open(capabilities_file))["capabilities"]
    else
        JSON.parse(JSON.open(capabilities_file))
    end

    capabilities_json = convert_units_recursive(capabilities_json_SI,capabilities_json_units)

    return Configurations.from_dict(DeviceCapabilities,capabilities_json)
end


# leave as SI units, needed for rounding purposes
"""
    get_device_capabilities_SI(capabilities_file=nothing)

Generates a `DeviceCapabilities` struct from either an explicitly provided path to a capabilities
JSON file or using the default JSON provided in "lib/BloqadeSchema/config/capabilities-qpu1-mock.json".

The values returned are in Base SI units: m, s, rad/s, etc.

```jldoctest;
julia> get_device_capabilities_SI()
BloqadeSchema.DeviceCapabilities(BloqadeSchema.TaskCapabilities(1, 1000), BloqadeSchema.LatticeCapabilities(BloqadeSchema.LatticeAreaCapabilities(7.5e-5, 7.6e-5), BloqadeSchema.LatticeGeometryCapabilities(4.0e-6, 4.0e-6, 1.0e-7, 256), 256), BloqadeSchema.RydbergCapabilities(5.42e-24, BloqadeSchema.RydbergGlobalCapabilities(0.0, 1.58e7, 400.0, 2.5e14, -1.25e8, 1.25e8, 0.2, 2.5e15, -99.0, 99.0, 5.0e-7, 0.0, 4.0e-6, 1.0e-9, 5.0e-8), nothing))
```
"""
function get_device_capabilities_SI(capabilities_file=nothing)

    capabilities_json = if isnothing(capabilities_file)
        capabilities_file = joinpath(pkgdir(@__MODULE__),"config","capabilities-qpu1-mock.json")
        JSON.parse(JSON.open(capabilities_file))["capabilities"]
    else
        JSON.parse(JSON.open(capabilities_file))
    end

    return Configurations.from_dict(DeviceCapabilities,capabilities_json)
end


"""
    get_rydberg_capabilities(;device_capabilities::DeviceCapabilities=get_device_capabilities())

Returns a named tuple containing values from the `RydbergCapabilities` field in `DeviceCapabilities`
designed to be used by [`validate`](@ref). Remaps fields in the structs to easier to access names:
(e.g.: `DeviceCapabilities.rydberg.global_value.time_delta_min` is now accessible as
`Ω.min_time_step`).
"""
function get_rydberg_capabilities(;device_capabilities::DeviceCapabilities=get_device_capabilities())
    return if isnothing(device_capabilities.rydberg.local_value)
        (
            Ω=(
                min_time_step = device_capabilities.rydberg.global_value.time_delta_min,
                time_resolution = device_capabilities.rydberg.global_value.time_resolution,
                max_time = device_capabilities.rydberg.global_value.time_max,
                max_value = device_capabilities.rydberg.global_value.rabi_frequency_max,
                min_value = device_capabilities.rydberg.global_value.rabi_frequency_min,
                max_slope = device_capabilities.rydberg.global_value.rabi_frequency_slew_rate_max,
                value_resolution = device_capabilities.rydberg.global_value.rabi_frequency_resolution
            ),
            ϕ = (
                min_time_step = device_capabilities.rydberg.global_value.time_delta_min,
                time_resolution = device_capabilities.rydberg.global_value.time_resolution,
                max_time = device_capabilities.rydberg.global_value.time_max,
                max_value = device_capabilities.rydberg.global_value.phase_max,
                min_value = device_capabilities.rydberg.global_value.phase_min,
                value_resolution = device_capabilities.rydberg.global_value.phase_resolution
            ),
            Δ = (
                min_time_step = device_capabilities.rydberg.global_value.time_delta_min,
                time_resolution = device_capabilities.rydberg.global_value.time_resolution,
                max_time = device_capabilities.rydberg.global_value.time_max,
                max_value = device_capabilities.rydberg.global_value.detuning_max,
                min_value = device_capabilities.rydberg.global_value.detuning_min,
                max_slope = device_capabilities.rydberg.global_value.detuning_slew_rate_max,
                value_resolution = device_capabilities.rydberg.global_value.detuning_resolution
            ),
            δ = nothing
        )
    else
        (
            Ω=(
                min_time_step = device_capabilities.rydberg.global_value.time_delta_min,
                time_resolution = device_capabilities.rydberg.global_value.time_resolution,
                max_time = device_capabilities.rydberg.global_value.time_max,
                max_value = device_capabilities.rydberg.global_value.rabi_frequency_max,
                min_value = device_capabilities.rydberg.global_value.rabi_frequency_min,
                max_slope = device_capabilities.rydberg.global_value.rabi_frequency_slew_rate_max,
                value_resolution = device_capabilities.rydberg.global_value.rabi_frequency_resolution
            ),
            ϕ = (
                min_time_step = device_capabilities.rydberg.global_value.time_delta_min,
                time_resolution = device_capabilities.rydberg.global_value.time_resolution,
                max_time = device_capabilities.rydberg.global_value.time_max,
                max_value = device_capabilities.rydberg.global_value.phase_max,
                min_value = device_capabilities.rydberg.global_value.phase_min,
                value_resolution = device_capabilities.rydberg.global_value.phase_resolution
            ),
            Δ = (
                min_time_step = device_capabilities.rydberg.global_value.time_delta_min,
                time_resolution = device_capabilities.rydberg.global_value.time_resolution,
                max_time = device_capabilities.rydberg.global_value.time_max,
                max_value = device_capabilities.rydberg.global_value.detuning_max,
                min_value = device_capabilities.rydberg.global_value.detuning_min,
                max_slope = device_capabilities.rydberg.global_value.detuning_slew_rate_max,
                value_resolution = device_capabilities.rydberg.global_value.detuning_resolution
            ),
            δ = (
                min_time_step = device_capabilities.rydberg.local_value.time_delta_min,
                time_resolution = device_capabilities.rydberg.local_value.time_resolution,
                max_time = device_capabilities.rydberg.global_value.time_max,
                max_value = device_capabilities.rydberg.local_value.detuning_max,
                min_value = device_capabilities.rydberg.local_value.detuning_min,
                max_slope = device_capabilities.rydberg.local_value.detuning_slew_rate_max,
                value_resolution = device_capabilities.rydberg.local_value.common_detuning_resolution,
                local_mask_resolution = device_capabilities.rydberg.local_value.local_detuning_resolution
            )
        )
    end
end

@inline function convert_units(value::Real,from,to)

    val = uconvert(to,Quantity(value,from)).val
    return round(val;sigdigits=14) 
end

function convert_units(x::AbstractArray{S},from,to) where {S<:Real}
    y = similar(x)
    @inbounds for i in eachindex(x)
        y[i] = convert_units(x[i],from,to)
    end
    return y
end



"""
    execute(j::String)

Executes a task given as a JSON string in the task specification API format, and returns a JSON string of the result
"""

function execute(j::String)
    execute(JSON.parse(j))
end

"""
    execute(j::Dict)

Executes a task given as a Dict in the task specification API format, and returns a JSON string of the result
"""
function execute(dict::AbstractDict{String})
    execute(Configurations.from_dict(BloqadeSchema.QuEraTaskSpecification,dict))
end


"""
    execute(j::QuEraTaskSpecification)

Executes a task given as a QuEraTaskSpecification object in the task specification API format, and returns a JSON string of the result
"""
function execute(task::QuEraTaskSpecification)
    h = from_schema(task)
        
    atoms,ϕ,Ω,Δ = get_rydberg_params(h)
    total_time = ϕ.duration
    n_atoms = length(atoms)

    reg = zero_state(n_atoms)
    problem = SchrodingerProblem(reg, total_time, h)
    BloqadeExpr.emulate!(problem)
    bitstrings = reg |> BloqadeExpr.measure(; nshots=task.nshots)

    return JSON.json(Configurations.to_dict(to_task_output(bitstrings)))
end




function to_task_output(bitstrings::Vector{<:BitBasis.BitStr64})
    shot_outputs = map(bitstrings) do bs
        # Assume perfect loading/sorting, so the initial loading is full
        pre_sequence = ones(length(bitstrings[1]))

        post_sequence = []
        for i in 1:length(bitstrings[1])
            append!(post_sequence, Int32(readbit(bs, i)))
        end

        return ShotOutput(;
            shot_status_code=200,
            pre_sequence=pre_sequence,
            post_sequence=post_sequence
        )
    end

    return TaskOutput(;
        task_status_code=200,
        shot_outputs=shot_outputs
    )
end

"""
    from_json(j::String)

Convert the JSON representation of a [`QuEraTaskSpecification`](@ref) instance to a 
[`QuEraTaskSpecification`](@ref)
"""
from_json(j::String) = BloqadeSchema.from_dict(JSON.parse(j))

"""
    from_dict(d::AbstractDict{String})

Convert the dictionary representation of a [`QuEraTaskSpecification`](@ref) instance, 
into a [`QuEraTaskSpecification`](@ref).
"""
function from_dict(d::AbstractDict{String})
    t = Configurations.from_dict(BloqadeSchema.QuEraTaskSpecification, d)
    return from_schema(t)
end

"""
    from_schema(t::QuEraTaskSpecification)

Converts `t` into valid `BloqadeExpr.RydbergHamiltonian` instance.
"""
function from_schema(t::QuEraTaskSpecification)
    atoms = (site for (i,site) in enumerate(t.lattice.sites) if t.lattice.filling[i] == 1)

    atoms = map(atoms) do pos 
        return convert_units.(pos,m,μm)
    end

    rabi_freq_amp = t.effective_hamiltonian.rydberg.rabi_frequency_amplitude.global_value
    rabi_freq_phase = t.effective_hamiltonian.rydberg.rabi_frequency_phase.global_value
    detuning_global = t.effective_hamiltonian.rydberg.detuning.global_value
    detuning_local = t.effective_hamiltonian.rydberg.detuning.local_value

    Ω = BloqadeWaveforms.piecewise_linear(; 
        clocks=convert_units(rabi_freq_amp.times,s,μs), 
        values=convert_units(rabi_freq_amp.values,rad/s,rad/μs)
    )
    ϕ = BloqadeWaveforms.piecewise_constant(;
        clocks=convert_units(rabi_freq_phase.times,s,μs),
        values=convert_units(rabi_freq_phase.values[1:end-1],rad,rad)
    )
    Δ = BloqadeWaveforms.piecewise_linear(;
        clocks=convert_units(detuning_global.times,s,μs),
        values=convert_units(detuning_global.values,rad/s,rad/μs)
    )
    if !isnothing(detuning_local)
        δ = BloqadeWaveforms.piecewise_linear(;
            clocks=convert_units(detuning_local.times,s,μs),
            values=convert_units(detuning_local.values,rad/s,rad/μs)
        )
        
        Δ_i = [Δ+δ_i*δ for (i,δ_i) in enumerate(detuning_local.lattice_site_coefficients) if t.lattice.filling[i] == 1]
    else
        Δ_i = Δ
    end

    return BloqadeExpr.rydberg_h(atoms; Δ=Δ_i, Ω=Ω, ϕ=ϕ)
end



"""
    to_json(h::AbstractBlock; kw...)
    to_json(h::BloqadeExpr.RydbergHamiltonian,params::SchemaTranslationParams)

Converts `h` and associated `params` into a JSON object.
If `params` is not explicitly provided as a `SchemaTranslationParams` instance, it is automatically built
from `nshots` and `device_capabilities`.

Validation is performed to ensure `h` is capable of being run on the machine. This can cause an
exception to be thrown should any violations be caught. Refer to Logs/Warnings/Exceptions below.

# Logs/Warnings/Exceptions

A `ValidationException` can be thrown which wraps a [`ValidationViolations`](@ref) instance.

`ValidationViolations` contains any constraint violations detected from [`to_schema`](@ref)

Violations include:

## Waveform Type
* ϕ is not of type `PiecewiseConstantWaveform`
* Ω and Δ are not of type `PiecewiseLinearWaveform`
## Atom Position
* Number of qubits requested exceeds what is supported by the device
* Atom positions exceed position resolution supported by the device
* The total width/height of the atom arrangement exceeds what is supported by the device
* The radial spacing between atoms is smaller than what is supported by the device
* The vertical row spacing between atoms is smaller than what is supported by the device
## General Waveform Constraints (apply to Ω, Δ, ϕ)
* duration exceeds device supported duration
* duration is smaller than device supported minimum time step
* smallest time step is smaller than supported smallest time step
* value is smaller than smallest supported value
* value is larger than largest supported value
## Ω Waveform specific constraints
* Slope exceeds largest supported slope
* Start and end values are not equal to 0.0 rad/μs
## Δ Waveform specific constraints
* Slope exceeds largest supported slope
## ϕ Waveform specific constraints
* start value is not equal to 0.0 rad/μs
## Miscellaneous Violations
* Number of shots is below minimum supported
* Number of shots exceeds maximum supported

# Examples

```jldoctest
julia> Ω = BloqadeWaveforms.piecewise_constant(; clocks=[0, 2, 4, 6, 7], values=[5, 3, 4, 6]);

julia> Δ = BloqadeWaveforms.piecewise_linear(; clocks=[0.0, 0.6, 2.1, 2.2], values=[-10.1, -10.1, 10.1, 10.1]);

julia> ϕ = BloqadeWaveforms.piecewise_linear(; clocks=[0, 5], values=[33, 0]);

julia> atoms = [(0, 0), (1, 3), (4, 2), (6, 3), (0, 5), (2, 5)];

julia> block = BloqadeExpr.rydberg_h(atoms; Δ=Δ, Ω=Ω, ϕ=ϕ);

julia> BloqadeSchema.to_json(block; n_shots=10)
"{\"nshots\":10,\"lattice\":{\"sites\":[[0.0,0.0],[1.0,3.0],[4.0,2.0],[6.0,3.0],[0.0,5.0],[2.0,5.0]],\"filling\":[1,1,1,1,1,1]},\"effective_hamiltonian\":{\"rydberg\":{\"rabi_frequency_amplitude\":{\"global\":{\"times\":[0.0,-18.0,2.0,-6.0,4.0,-14.0,7.0],\"values\":[5.0,5.0,3.0,3.0,4.0,4.0,6.0]}},\"rabi_frequency_phase\":{\"global\":{\"times\":[0.0,5.0],\"values\":[33.0,0.0]}},\"detuning\":{\"global\":{\"times\":[0.0,0.6,2.1,2.2],\"values\":[-10.1,-10.1,10.1,10.1]}}}}}"
```
"""
to_json(h::BloqadeExpr.RydbergHamiltonian; kw...) = to_json(h,SchemaTranslationParams(;kw...))

"""
    to_dict(h::BloqadeExpr.RydbergHamiltonian; nshots::Int, device_capabilities::DeviceCapabilities=get_device_capabilities())
    to_dict(h::BloqadeExpr.RydbergHamiltonian,params::SchemaTranslationParams)

Converts `h` and associated `params` into the dictionary representation of a [`QuEraTaskSpecification`](@ref).
If `params` is not explicitly provided as a `SchemaTranslationParams` instance, it is automatically built
from `nshots` and `device_capabilities`.

Validation is performed to ensure `h` is capable of being run on the machine. This can cause an
exception to be thrown should any violations be caught. Refer to Logs/Warnings/Exceptions below.

# Logs/Warnings/Exceptions

A `ValidationException` can be thrown which wraps a [`ValidationViolations`](@ref) instance.

`ValidationViolations` contains any constraint violations detected from [`to_schema`](@ref)

Violations include:

## Waveform Type
* ϕ is not of type `PiecewiseConstantWaveform`
* Ω and Δ are not of type `PiecewiseLinearWaveform`
## Atom Position
* Number of qubits requested exceeds what is supported by the device
* Atom positions exceed position resolution supported by the device
* The total width/height of the atom arrangement exceeds what is supported by the device
* The radial spacing between atoms is smaller than what is supported by the device
* The vertical row spacing between atoms is smaller than what is supported by the device
## General Waveform Constraints (apply to Ω, Δ, ϕ)
* duration exceeds device supported duration
* duration is smaller than device supported minimum time step
* smallest time step is smaller than supported smallest time step
* value is smaller than smallest supported value
* value is larger than largest supported value
## Ω Waveform specific constraints
* Slope exceeds largest supported slope
* Start and end values are not equal to 0.0 rad/μs
## Δ Waveform specific constraints
* Slope exceeds largest supported slope
## ϕ Waveform specific constraints
* start value is not equal to 0.0 rad/μs
## Miscellaneous Violations
* Number of shots is below minimum supported
* Number of shots exceeds maximum supported

"""
to_dict(h::BloqadeExpr.RydbergHamiltonian; kw...) = to_dict(h,SchemaTranslationParams(;kw...))

"""
    to_schema(h::BloqadeExpr.RydbergHamiltonian; nshots::Int, device_capabilities::DeviceCapabilities=get_device_capabilities())
    to_schema(h::BloqadeExpr.RydbergHamiltonian, params::SchemaTranslationParams)

Converts `h` to a `QuEraTaskSpecification` instance with `params`. If params is not explicitly constructed, 
it will be built automatically from `nshots` and `device_capabilities`. 

Validation is performed to ensure `h` is capable of being run on the machine. This can cause an
exception to be thrown should any violations be caught. Refer to Logs/Warnings/Exceptions below.

# Logs/Warnings/Exceptions

If any violations of `device_capabilities` are detected, a `ValidationException` is thrown which wraps
a [`ValidationViolations`](@ref) instance.

Violations include:

## Waveform Type
* ϕ is not of type `PiecewiseConstantWaveform`
* Ω and Δ are not of type `PiecewiseLinearWaveform`
## Atom Position
* Number of qubits requested exceeds what is supported by the device
* Atom positions exceed position resolution supported by the device
* The total width/height of the atom arrangement exceeds what is supported by the device
* The vertical row spacing between atoms is smaller than what is supported by the device
* The radial spacing between atoms is smaller than what is supported by the device
## General Waveform Constraints (apply to Ω, Δ, ϕ)
* duration exceeds device supported duration
* duration is smaller than device supported minimum time step
* smallest time step is smaller than supported smallest time step
* value is smaller than smallest supported value
* value is larger than largest supported value
## Ω Waveform specific constraints
* Slope exceeds largest supported slope
* Start and end values are not equal to 0.0 rad/μs
## Δ Waveform specific constraints
* Slope exceeds largest supported slope
## ϕ Waveform specific constraints
* start value is not equal to 0.0 rad/μs
## Miscellaneous Violations
* Number of shots is below minimum supported
* Number of shots exceeds maximum supported
"""
to_schema(h::BloqadeExpr.RydbergHamiltonian; kw...) = to_schema(h,SchemaTranslationParams(;kw...))

function to_json(h::BloqadeExpr.RydbergHamiltonian,params::SchemaTranslationParams)
    return JSON.json(BloqadeSchema.to_dict(h,params))
end

function to_dict(h::BloqadeExpr.RydbergHamiltonian,params::SchemaTranslationParams)
    return Configurations.to_dict(to_schema(h,params))
end

function to_schema(h::BloqadeExpr.RydbergHamiltonian, params::SchemaTranslationParams)
    atoms,ϕ,Ω,Δ,δ,Δi = schema_parse_rydberg_fields(h)

    violations = validate_analog_params(atoms,ϕ,Ω,Δ,δ,Δi,params.device_capabilities)

    params.n_shots < params.device_capabilities.task.number_shots_min && push!(violations.misc_violations,
        "n_shots $(params.n_shots) is less than minimum value $(params.device_capabilities.task.number_shots_min)"
    )
    params.n_shots > params.device_capabilities.task.number_shots_max && push!(violations.misc_violations,
        "n_shots $(params.n_shots) is exceeds maximum value $(params.device_capabilities.task.number_shots_max)"
    )

    if !isempty(violations)
        throw(ValidationException(violations))
    end

    ϕ =(
        clocks=ϕ.f.clocks,
        values=[ϕ.f.values...,ϕ.f.values[end]] # add extra element at the end 
    )

    Ω = (
        clocks=Ω.f.clocks,
        values=Ω.f.values
    )

    Δ = (
        clocks=Δ.f.clocks,
        values=Δ.f.values
    )

    δ = if !isnothing(δ) 
        (
            clocks=δ.f.clocks,
            values=δ.f.values
        )
    end

    return QuEraTaskSpecification(;
        nshots=params.n_shots,
        lattice=to_lattice(atoms),
        effective_hamiltonian=to_hamiltonian(Ω, ϕ, Δ, δ, Δi)
    )
end

"""
    to_json_no_validation(lattice::Union{Vector,Lattice};
        ϕ::Maybe{PiecewiseConstantWaveform}=nothing,
        Ω::Maybe{PiecewiseLinearWaveform}=nothing,
        Δ::Maybe{PiecewiseLinearWaveform}=nothing,
        δ::Maybe{PiecewiseLinearWaveform}=nothing,
        Δi::Maybe{Vector{Number}}=nothing,kw...)

Converts `lattice`, `ϕ`, `Δ`, `δ`, and `Δi` to a JSON representation of a `QuEraTaskSpecification` instance
WITHOUT ensuring the provided values are capable of being executed on the machine (fit within the 
constraints of the device's capabilities)

See also [`to_json`](@ref)
"""
function to_json_no_validation(lattice::Union{Vector,Lattice};
    ϕ::Maybe{PiecewiseConstantWaveform}=nothing,
    Ω::Maybe{PiecewiseLinearWaveform}=nothing,
    Δ::Maybe{PiecewiseLinearWaveform}=nothing,
    δ::Maybe{PiecewiseLinearWaveform}=nothing,
    Δi::Maybe{Vector{Number}}=nothing,kw...)
    schema = to_schema_no_validation(lattice,ϕ,Ω,Δ,δ,Δi,SchemaTranslationParams(;kw...))
    return JSON.json(Configurations.to_dict(schema))
end

"""
    to_schema_no_validation(lattice::Union{Vector,Lattice};
        ϕ::Maybe{PiecewiseConstantWaveform}=nothing,
        Ω::Maybe{PiecewiseLinearWaveform}=nothing,
        Δ::Maybe{PiecewiseLinearWaveform}=nothing,
        δ::Maybe{PiecewiseLinearWaveform}=nothing,
        Δi::Maybe{Vector{Number}}=nothing, 
        nshots::Int,
        device_capabilities::DeviceCapabilities=get_device_capabilities())
    to_schema_no_validation(lattice::Union{Vector,Lattice},
        ϕ::Maybe{PiecewiseConstantWaveform},
        Ω::Maybe{PiecewiseLinearWaveform},
        Δ::Maybe{PiecewiseLinearWaveform},
        δ::Maybe{PiecewiseLinearWaveform},
        Δi::Maybe{Vector{Number}}, 
        params::SchemaTranslationParams)

Converts `lattice`, `ϕ`, `Δ`, `δ`, and `Δi` to a `QuEraTaskSpecification` instance
WITHOUT ensuring the provided values are capable of being executed on the machine (fit within the 
constraints of the device's capabilities).

If `params` is not already provided, it is constructed automatically from `nshots::Int`
and `device_capabilities`.

See also [`to_schema`](@ref)
"""
function to_schema_no_validation(lattice::Union{Vector,Lattice};
    ϕ::Maybe{PiecewiseConstantWaveform}=nothing,
    Ω::Maybe{PiecewiseLinearWaveform}=nothing,
    Δ::Maybe{PiecewiseLinearWaveform}=nothing,
    δ::Maybe{PiecewiseLinearWaveform}=nothing,
    Δi::Maybe{Vector{Number}}=nothing, 
    kw...)
    return to_schema_no_validation(lattice,ϕ,Ω,Δ,δ,Δi,SchemaTranslationParams(;kw...))
end

function to_schema_no_validation(lattice::Union{Vector,Lattice},
    ϕ::Maybe{PiecewiseConstantWaveform},
    Ω::Maybe{PiecewiseLinearWaveform},
    Δ::Maybe{PiecewiseLinearWaveform},
    δ::Maybe{PiecewiseLinearWaveform},
    Δi::Maybe{Vector{Number}}, 
    params::SchemaTranslationParams)
    
    duration = params.device_capabilities.rydberg.global_value.time_delta_min
    # take maximum value for duration
    
    for wf in [Ω,Δ,ϕ]
        duration =  (!isnothing(wf) ? max(wf.duration,duration) : duration)
    end

    ϕ = if !isnothing(ϕ)
        (
            clocks=ϕ.f.clocks,
            values=[ϕ.f.values...,ϕ.f.values[end]] # add extra element at the end 
        )
    else
        (
            clocks = [0.0,0.0],
            values = [0.0,duration]
        )
    end

    Ω = if !isnothing(Ω)
        (
            clocks=Ω.f.clocks,
            values=Ω.f.values
        )
    else
        (
            clocks = [0.0,0.0],
            values = [0.0,duration]
        )
    end

    Δ =  if !isnothing(Δ) 
        (
            clocks=Δ.f.clocks,
            values=Δ.f.values
        )
    else
        (
            clocks = [0.0,0.0],
            values = [0.0,duration]
        )
    end

    δ = if !isnothing(δ)  
        (
            clocks=δ.f.clocks,
            values=δ.f.values
        )
    end

    return QuEraTaskSpecification(;
        nshots=params.n_shots,
        lattice=to_lattice(lattice),
        effective_hamiltonian=to_hamiltonian(Ω, ϕ, Δ, δ, Δi)
    )

end

to_lattice(lattice::Lattice) = Lattice(
    sites = [convert_units.(site,μm,m) for site in lattice.sites],
    filling = lattice.filling
)

function to_lattice(atoms::Vector)
    coords = map(atoms) do coord
        length(coord) == 1 && return convert_units.((coord[1], 0),μm,m)
        return convert_units.(coord,μm,m)
    end
    return Lattice(; sites = coords, filling = vec(ones(length(coords), 1)))
end



function to_hamiltonian(
    Ω::NamedTuple,
    ϕ::NamedTuple,
    Δ::NamedTuple,
    δ::NamedTuple,
    Δ_i::Vector{<:Real}) 

    return EffectiveHamiltonian(;
        rydberg = RydbergHamiltonian(;
            rabi_frequency_amplitude = RabiFrequencyAmplitude(;
                global_value = GlobalField(; 
                    times = convert_units.(Ω.clocks,μs,s), 
                    values = convert_units.(Ω.values,rad/μs,rad/s)
                ),
            ),
            rabi_frequency_phase = RabiFrequencyPhase(;
                global_value = GlobalField(; 
                    times = convert_units.(ϕ.clocks,μs,s),
                    values = convert_units.(ϕ.values,rad,rad)
                ),
            ),
            detuning = Detuning(;
                global_value = GlobalField(; 
                    times = convert_units.(Δ.clocks,μs,s), 
                    values = convert_units.(Δ.values,rad/μs,rad/s)
                ),
                local_value = LocalField(; 
                    times = convert_units.(δ.clocks,μs,s), 
                    values = convert_units.(δ.values,rad/μs,rad/s), 
                    lattice_site_coefficients=Δ_i
                )
            ),
        ),
    )
end

function to_hamiltonian(
    Ω::NamedTuple,
    ϕ::NamedTuple,
    Δ::NamedTuple,
    δ::Nothing,
    Δ_i::Maybe{Real})

    return EffectiveHamiltonian(;
        rydberg = RydbergHamiltonian(;
            rabi_frequency_amplitude = RabiFrequencyAmplitude(;
                global_value = GlobalField(; 
                    times = convert_units.(Ω.clocks,μs,s), 
                    values = convert_units.(Ω.values,rad/μs,rad/s)
                ),
            ),
            rabi_frequency_phase = RabiFrequencyPhase(;
                global_value = GlobalField(; 
                    times = convert_units.(ϕ.clocks,μs,s),
                    values = convert_units.(ϕ.values,rad,rad)
                ),
            ),
            detuning = Detuning(;
                global_value = GlobalField(; 
                    times = convert_units.(Δ.clocks,μs,s), 
                    values = convert_units.(Δ.values,rad/μs,rad/s)
                )
            ),
        ),
    )
end

using BloqadeSchema
using Bloqade
using JSON


# preparing 2D checkboard phase. For more details, see https://queracomputing.github.io/Bloqade.jl/dev/tutorials/2.adiabatic/main/

nx, ny = 3, 3
nsites = nx * ny
atoms = generate_sites(SquareLattice(), nx, ny, scale = 6.7)

total_time = 2.9
Ω_max = 2π * 4.3
Ω = piecewise_linear(clocks = [0.0, 0.3, 2.6, total_time], values = [0.0, Ω_max, Ω_max, 0]);

U = 2π * 15.0
Δ = piecewise_linear(clocks = [0.0, 0.3, 2.6, total_time], values = [-U, -U, U, U]);

ϕ = constant(;duration = total_time ,value = 0)

h = rydberg_h(atoms; Δ, Ω, ϕ)
h_hardware, info = hardware_transform(h)
h = to_json(h_hardware)

open("lib/BloqadeSchema/schema_examples/tutorial_examples/2D_checkboard.json","w") do f
    JSON.print(f, JSON.parse(h))
end

# this function is required to calculate difference
# between waveforms which have different durations.
# the behavior is to pad the shorter waveform at the
# end with 0. This is useful when the user passes
# in a duration that doesn't neatly fit into the
# time resolution of the device. In which case 
# this is required to check the error.
function norm_diff_durations(A::Waveform,B::Waveform)
    A.duration==B.duration && return norm(A-B)

    if A.duration > B.duration
        T_diff = A.duration - B.duration
        B = append(B,constant(;duration=T_diff,value=0))
        return norm(A-B)
    else
        T_diff = B.duration - A.duration
        A = append(A,constant(;duration=T_diff,value=0))
        return norm(A-B)
    end
end

# simple function, round number to the nearest multiple of `res`
function set_resolution(x::Real,res::Real)
    @assert res > 0
    return round(Int(round(x / res)) * res,sigdigits=14)
end

# throws error for non-scalar fields
function  check_global(field,name) 
    field isa AbstractArray && error("Failed to transform $name to hardware, $name must be global drive.")
end

# checks argument to make sure it is a waveform or a container of waveforms.
function check_waveform(field,name)
    field isa Waveform{F,T} where {F,T<:Real} && return 
        
    field isa Vector{<:Number} && error("Failed to transform $name to hardware, $name must be a vector Waveforms.\n If $name contains constant values use `BloqadeWaveforms.constant`.")
    if field isa Vector 
        foreach(field) do ele
            !(ele isa Waveform{F,T} where {F,T<:Real})  && error("Failed to transform $name to hardware, $name must be a Waveform.")
        end

        duration = field[1].duration
        foreach(field) do ele
            duration != ele.duration && error("Failed to transform $name to hardware, all Waveforms must have the same duration.")
        end

        return

    end
    # enforce requirement that ALL waveforms must be present prior to invoking hardware_transform (Bloqade doesn't assume any default values).
    # Transform fails otherwise!
    isnothing(field) && error("$name must be specified prior to transform to hardware compatible format.\n You can specify the absence of a waveform by passing in a constant waveform (use `BloqadeWaveforms.constant`) with value set to zero.")
    (field isa Number || BloqadeExpr.is_time_function(field)) && error("Failed to transform $name to hardware, $name must be a Waveform.\n If $name is constant or zero use `BloqadeWaveforms.constant`.")

end
# warns user if the duration of the waveform will be rounded by the time resolution.
function warn_duration(time_res,field,name)
    duration = if field isa Vector
        field[1].duration
    else
        field.duration
    end
    if !(set_resolution(duration,time_res) ≈ duration)
        @debug "waveform $name duration will be rounded during hardware transformation."
    end
end

# TODO: move this to BloqadeWaveforms
# function inserts ramps at the beginning and end to set correct initial and final values
# two methods, one for general waveform, other is for specifically PWL waveforms
function pin_waveform_edges(wf::Waveform,name,
    max_slope::Real,
    begin_value::Real,
    end_value::Real)

    
    duration = wf.duration

    wf_begin = wf(zero(duration))
    wf_end = wf(duration)

    
    # 
    t_begin = if !isapprox(wf_begin, begin_value;atol=eps(),rtol=√eps())
        @debug "During hardware transform: $name(t) initial value is not $begin_value. adding ramp to fix endpoints."
        ramp_up =  (sign(wf_begin-begin_value)*max_slope)
        lin_ramp_begin = Waveform(t -> ramp_up .* t .+ begin_value, duration)
        find_zero(wf-lin_ramp_begin,(zero(duration),duration))
    else
        zero(duration)
    end

    t_end = if !isapprox(wf_end, end_value;atol=eps(),rtol=√eps())
        @debug "During hardware transform: $name(t) end value is not $end_value. adding ramp to fix endpoints."
        ramp_down = (sign(end_value-wf_end)*max_slope)
        lin_ramp_end = Waveform(t -> ramp_down * (t-duration) + end_value, duration)
        find_zero(wf-lin_ramp_end,(zero(duration),duration))
    else
        duration
    end

    # not the best solution but will 
    if t_begin > t_end
        t_begin = duration/2
        t_end = duration/2

        start_wf = linear_ramp(;
            duration=t_begin,
            start_value=begin_value,
            stop_value=wf(t_begin)
        )

        end_wf = linear_ramp(;
            duration=t_end,
            start_value=wf(t_end),
            stop_value=end_value
        )

        return append(start_wf,end_wf)        
    elseif t_begin > 0 && t_end < duration
        mid_wf = wf[t_begin..t_end]

        start_wf = linear_ramp(;
            duration=t_begin,
            start_value=begin_value,
            stop_value=wf(t_begin)
        )

        end_wf = linear_ramp(;
            duration=duration-t_end,
            start_value=wf(t_end),
            stop_value=end_value
        )


        return append(start_wf,mid_wf,end_wf)
    elseif t_begin > 0 
        end_wf = wf[t_begin..duration]
        start_wf = linear_ramp(;duration=t_begin,
            start_value=begin_value,
            stop_value=wf(t_begin)
        )

        return append(start_wf,end_wf)
    elseif t_end < duration
        start_wf = wf[0..t_end]

        end_wf = linear_ramp(;duration=duration-t_end,
            start_value=wf(t_end),
            stop_value=end_value
        )

        return append(start_wf,end_wf)
    else
        return wf      
    end

end

#=
function find_local_masks(values::Array{T,2};name::Symbol=:Waveform,ntrunc::Int=1, assert_truncation::Bool=false) where T
    
    (l,w) = size(values)
    
    # project out uniform amplitude waveforms
    ones_norm = ones(w,1)./sqrt(w)
    avg = (values*ones_norm)*transpose(ones_norm)
    results = []
    values = values - avg
    avg = avg[:,1]

    if ntrunc > 0
        # use SVD to decompose the non-uniform waveforms
        # if there are more than one singular value larger than 0 the remaining pattern
        # can't be described as a local detuning mask times a single time-dependent function.
        # here we truncate the waveform only keeping the first singular value.
        u,s,v_T = svd(values)
        contained_weight = sum(s[1:ntrunc])
        
        remaining_weight = sum(s[(ntrunc+1):end])

        if remaining_weight > eps()*length(s)*contained_weight
            error_or_warn(assert_truncation,"Cannot decompose $name into product of masks and scalar functions.")
        end

        for i in 1:ntrunc

            mask = if all(u[:,i] .<= 0) # make u all positive
                u[:,i] .*= -1
                (-s[i] .* v_T[:,i])

            else
                s[i] .* v_T[:,i]
            end

            min = minimum(mask)
            max = maximum(mask)

            mask = (mask .- min) ./ (max - min)

            f = u[:,i] .* (max - min)
            avg .+= u[:,i] .* min

            push!(results,(f,mask))
        end
    end

    push!(results,(avg,ones(w)))
    return results

end
=#

function clip_waveform(wf::Waveform{BloqadeWaveforms.PiecewiseLinear{T,I},T},name,min_value::T,max_value::T) where {T<:Real,I}
    #=
    FROM JULIA DOCS:
    !!! warning An assert might be disabled at various optimization levels. 
    Assert should therefore only be used as a debugging tool and not used for 
    authentication verification (e.g., verifying passwords), 
    nor should side effects needed for the function to work correctly be used inside of asserts.
    =#
    # ensure that the maximum value of waveform is greater than minimum value
    @assert min_value < max_value

    # for each value, if a value is greater than the maximum permitted or smaller than the smallest permitted, 
    # issue notice to user that clipping must occur
    for value in wf.f.values
        if value > max_value || value < min_value
            @debug "During hardware transform: $name(t) falls outside of hardware bounds, clipping to maximum/minimum."
            break
        end
    end

    return piecewise_linear(;clocks=wf.f.clocks,values=map(wf.f.values) do value
            return min(max_value,max(min_value,value))
        end
    )
end

function clip_waveform(wf::Waveform{BloqadeWaveforms.PiecewiseConstant{T},T},name,min_value::T,max_value::T) where {T<:Real}
    @assert min_value < max_value

    for value in wf.f.values
        if value > max_value || value < min_value
            @debug "During hardware transform: $name(t) falls outside of hardware bounds, clipping to maximum/minimum."
            break
        end
    end

    return piecewise_constant(;clocks=wf.f.clocks,values=map(wf.f.values) do value
            return min(max_value,max(min_value,value))
        end
    )
end


function hardware_transform_parse(h::BloqadeExpr.RydbergHamiltonian,device_capabilities::DeviceCapabilities)
    (atoms,ϕ,Ω,Δ) = get_rydberg_params(h)
    Δ_mask = (Δ=Δ,δ=nothing,Δi=1.0)

    ϕ,ϕ_error = hardware_transform_ϕ(ϕ,device_capabilities)
    Ω,Ω_error = hardware_transform_Ω(Ω,device_capabilities)
    Δ,Δ_error = hardware_transform_Δ(Δ,device_capabilities)
    atoms,mse_atoms = hardware_transform_atoms(atoms,device_capabilities)

    info = HardwareTransformInfo(ϕ_error=ϕ_error,Ω_error=Ω_error,Δ_error=Δ_error,Δ_mask=Δ_mask,mse_atoms=mse_atoms)

    return (atoms,ϕ,Ω,Δ,info)
end

# public API exposed here: 
"""
    hardware_transform_Ω(Ω,device_capabilities::DeviceCapabilities=get_device_capabilities())

Given the `device_capabilities` of the machine and a Rabi frequency (Ω) [`Waveform`](@ref),
return a transformed Ω capable of being implemented by the machine along with
the error between the original (``A``) and transformed (``B``)
waveforms calculated as ``\\Vert A - B\\Vert_1``. If the waveform durations are different,
the shorter waveform is padded with zeros for values to make the durations equal in error calculation.

# Logs/Warnings/Exceptions

Exceptions are thrown if Ω is:
- Not of type [`BloqadWaveforms.Waveform`](@ref)
- Not present (`nothing` was passed in)
- Not a global drive (e.g.: Vector of Waveforms, localized Ω is not supported)
- the maximum slope allowed for the waveform from `device_capabilities` is set to infinity 
- the minimum time step allowed for the waveform from `device_capabilities` is set to zero


Debug logs are issued if the following are encountered in Ω:
- duration may be rounded due to time resolution from `device_capabilities`
- the initial waveform does not start/end in zero for its value
- the values in the waveform exceed `device_capabilities` supported values, and must be clipped 

# Examples
```jldoctest; setup:=(using BloqadeWaveforms)
julia> wf = sinusoidal(duration=2, amplitude=1.3*π);

julia> hardware_transform_Ω(wf)
(Waveform(_, 2.0), 2.632451578170084)
```
"""
function hardware_transform_Ω(Ω,device_capabilities::DeviceCapabilities=get_device_capabilities())
    time_res = device_capabilities.rydberg.global_value.time_resolution
    min_step = device_capabilities.rydberg.global_value.time_delta_min
    rabi_res = device_capabilities.rydberg.global_value.rabi_frequency_resolution
    max_slope = device_capabilities.rydberg.global_value.rabi_frequency_slew_rate_max
    max_value = device_capabilities.rydberg.global_value.rabi_frequency_max
    min_value = device_capabilities.rydberg.global_value.rabi_frequency_min

    check_waveform(Ω,:Ω)
    check_global(Ω,:Ω)
    warn_duration(time_res,Ω,:Ω)

    Ω = pin_waveform_edges(Ω,:Ω,max_slope,0,0)


    Ωt = if Ω isa PiecewiseLinearWaveform
        piecewise_linear(;
            clocks=set_resolution.(Ω.f.clocks,time_res),
            values=set_resolution.(Ω.f.values,rabi_res)
        )

    elseif Ω isa Waveform{F,T} where {F,T<:Real}
        
        Ω_interp = piecewise_linear_interpolate(Ω,max_slope=max_slope,min_step=min_step,atol=0)
        piecewise_linear(;
            clocks=set_resolution.(Ω_interp.f.clocks,time_res),
            values=set_resolution.(Ω_interp.f.values,rabi_res)
        )
    end

    Ωt = clip_waveform(Ωt,:Ω,min_value,max_value)
    return Ωt,norm_diff_durations(Ω,Ωt)
end

"""
    hardware_transform_ϕ(ϕ,device_capabilities::DeviceCapabilities=get_device_capabilities())

Given the `device_capabilities` of the machine and a phase [`Waveform`](@ref),
return a transformed ϕ capable of being implemented by the machine along with
the error between the original (``A``) and transformed (``B``)
waveforms calculated as ``\\Vert A - B\\Vert_1``. If the waveform durations are different,
the shorter waveform is padded with zeros for values to make the durations equal in error calculation.

# Logs/Warnings/Exceptions

Exceptions are thrown if ϕ is:
- Not of type [`BloqadWaveforms.Waveform`](@ref)
- Not present (`nothing` was passed in)
- Not a global drive (e.g.: Vector of Waveforms, localized ϕ is not supported)
- the maximum slope allowed for the waveform from `device_capabilities` is set to infinity 
- the minimum time step allowed for the waveform from `device_capabilities` is set to zero


Debug logs are issued if the following are encountered in ϕ:
- duration may be rounded due to time resolution from `device_capabilities`
- the initial waveform does not start/end in zero for its value
- the values in the waveform exceed `device_capabilities` supported values, and must be clipped 

# Examples
```jldoctest; setup:=(using BloqadeWaveforms)
julia> wf = sinusoidal(duration=2, amplitude=1.3*π);

julia> hardware_transform_ϕ(wf)
(Waveform(_, 2.0), 0.5386117854062276)
```
"""
function hardware_transform_ϕ(ϕ,device_capabilities::DeviceCapabilities=get_device_capabilities())

    time_res = device_capabilities.rydberg.global_value.time_resolution
    min_step = device_capabilities.rydberg.global_value.time_delta_min
    phase_res = device_capabilities.rydberg.global_value.phase_resolution
    max_value = device_capabilities.rydberg.global_value.phase_max
    min_value = device_capabilities.rydberg.global_value.phase_min

    # Can't feed in array of waveforms for ϕ
    check_global(ϕ,:ϕ)
    # check that it actually is a waveform (ex: an int/float constant can't be a waveform)
    check_waveform(ϕ,:ϕ)
    # warn if duration will be rounded to time resolution
    warn_duration(time_res,ϕ,:ϕ)

    ϕt = if ϕ isa PiecewiseConstantWaveform
        piecewise_constant(;
            clocks=set_resolution.(ϕ.f.clocks,time_res),
            values=set_resolution.(ϕ.f.values,phase_res)
        )        

    elseif ϕ isa Waveform{F,T} where {F,T<:Real} # handle the more general case
        # arbitrary waveform must transform
        ϕ_interp = piecewise_constant_interpolate(ϕ,min_step=min_step,atol=0)
        piecewise_constant(;
            clocks=set_resolution.(ϕ_interp.f.clocks,time_res),
            values=set_resolution.(ϕ_interp.f.values,phase_res)
        )
    end 
    # simply clip value to make waveform consistent
    if !isapprox(ϕt(zero(ϕt.duration)),zero(ϕt.duration);atol=eps()) 
        ϕt.f.values[1] = zero(ϕt.duration)
    end

    ϕt = clip_waveform(ϕt,:ϕ,min_value,max_value)
    return ϕt,norm_diff_durations(ϕ,ϕt)
end

"""
    hardware_transform_Δ(Δ,device_capabilities::DeviceCapabilities=get_device_capabilities())

Given the `device_capabilities` of the machine and a detuning waveform Δ,
return a transformed Δ capable of being implemented by the machine along with
the error between the original (``A``) and transformed (``B``)
waveforms calculated as ``\\Vert A - B\\Vert_1``. If the waveform durations are different,
the shorter waveform is padded with zeros for values to make the durations equal in error calculation.

# Logs/Warnings/Exceptions

Exceptions are thrown if Δ is:
- Not of type [`BloqadWaveforms.Waveform`](@ref)
- Not present (`nothing` was passed in)
- Not a global drive (e.g. Vector of Waveforms, localized Δ is not supported)
- the maximum slope allowed for the waveform from `device_capabilities` is set to infinity 
- the minimum time step allowed for the waveform from `device_capabilities` is set to zero


Debug logs are issued if the following are encountered in Δ:
- duration may be rounded due to time resolution from `device_capabilities`
- the initial waveform does not start/end in zero for its value
- the values in the waveform exceed `device_capabilities` supported values, and must be clipped 

# Examples
```jldoctest; setup:=(using BloqadeWaveforms)
julia> wf = sinusoidal(duration=2, amplitude=1.3*π);

julia> hardware_transform_Δ(wf)
(Waveform(_, 2.0), 0.06492452289703464)
```
"""
function hardware_transform_Δ(Δ,device_capabilities::DeviceCapabilities=get_device_capabilities())

    time_res = device_capabilities.rydberg.global_value.time_resolution
    min_step = device_capabilities.rydberg.global_value.time_delta_min
    
    detune_res = device_capabilities.rydberg.global_value.detuning_resolution
    # local_res = device_capabilities.rydberg.local_value.local_detuning_resolution
    # common_detune_res = device_capabilities.rydberg.local_value.common_detuning_resolution
    max_slope = device_capabilities.rydberg.global_value.detuning_slew_rate_max
    max_value = device_capabilities.rydberg.global_value.detuning_max
    min_value = device_capabilities.rydberg.global_value.detuning_min


    check_waveform(Δ,:Δ)
    check_global(Δ,:Δ)
    warn_duration(time_res,Δ,:Δ)
    


    if Δ isa PiecewiseLinearWaveform
        Δt = piecewise_linear(;
            clocks=set_resolution.(Δ.f.clocks,time_res),
            values=set_resolution.(Δ.f.values,detune_res)
        )
        Δt = clip_waveform(Δt,:Δ,min_value,max_value)
        return Δt,norm_diff_durations(Δ,Δt)

    elseif Δ isa Waveform{F,T} where {F,T<:Real}
        # arbitrary waveform must transform
        
        Δ_interp = piecewise_linear_interpolate(Δ,max_slope=max_slope,min_step=min_step,atol=0)
        Δt = piecewise_linear(;
            clocks=set_resolution.(Δ_interp.f.clocks,time_res),
            values=set_resolution.(Δ_interp.f.values,detune_res)
        )

        Δt = clip_waveform(Δt,:Δ,min_value,max_value)

        return Δt,norm_diff_durations(Δ,Δt)
    elseif Δ isa Vector
        error("Local detuning not implemented in Schema.")
        #=
        duration = Δ[1].duration
        nsteps = Int((duration+duration%min_step)÷min_step)
        clocks = collect(LinRange(0.0,duration,nsteps))
        clocks = set_resolution.(clocks,time_res)

        values = zeros(length(clocks),length(Δ))

        @inbounds for (j,δ) in enumerate(Δ)
            values[:,j] = δ.(clocks)
        end

        ((δ_values,Δi),(Δ_values,_)) = find_local_masks(values;name=:Δ)

        Δ_values = set_resolution.(Δ_values,detune_res)
        δ_values = set_resolution.(δ_values,common_detune_res)
        Δi = set_resolution.(Δi,local_res)

        Δ_mask = (
            Δ=piecewise_linear(;clocks=clocks,values=Δ_values),
            δ=piecewise_linear(;clocks=clocks,values=Δ_values),
            Δi=Δi
        )
        Δt = [piecewise_linear(;clocks=clocks,values=Δ_values+δi.*δ_values) for δi in Δi]
        error = [norm_diff_durations(δ,δt) for (δ,δt) in zip(Δ,Δt)]

        return Δt,error,Δ_mask
        =#
    end


end

"""
    hardware_transform_atoms(atoms,device_capabilities::DeviceCapabilities=get_device_capabilities())

Given the constraints of the hardware from `device_capabilities` (specifically the position resolution)
and an iterable containing the atom positions `atoms`, returns a Tuple containing the adjusted 
atom positions the machine is capable of resolving and the mean squared error between the 
desired atom positions and newly generated ones.

Note that other constraints such as the maximum width, height, and minimum supported spacings
are not taken into account in adjusting the atoms. This may result in the [`validation`](@ref) 
function failing and requiring user intervention to modify the atom positions such that 
they satisfy the other constraints.

# Examples 
```jldoctest;
julia> atom_positions = ((1.12,), (2.01,), (3.01,));

julia> hardware_transform_atoms(atom_positions) # by default, calls get_device_capabilities()
([(1.1,), (2.0,), (3.0,)], 0.013333333333333197)
```
"""
function hardware_transform_atoms(atoms,device_capabilities::DeviceCapabilities=get_device_capabilities())

    pos_resolution = device_capabilities.lattice.geometry.position_resolution

    new_atoms = [set_resolution.(pos,pos_resolution) for pos in atoms]

    mse_atoms = sum(√sum((x.-y).^2) for (x,y) in zip(new_atoms,atoms))/length(new_atoms)

    return new_atoms,mse_atoms

end

"""
    hardware_transform(h::BloqadeExpr.RydbergHamiltonian;device_capabilities::DeviceCapabilities=get_device_capabilities())

Given the constraints of the hardware via `device_capabilities`, transforms `h` into one the
machine is capable of executing as well as:
* The mean squared error between original positions of the atoms and the transformed ones
* The 1-norm of the difference between the original and transformed waveforms
which are all stored in a [`HardwareTransformInfo`](@ref) struct.

`hardware_transform` expects that ALL waveforms `h` can have specified (Ω, Δ, ϕ) are explicitly defined.
If there is a waveform that is not being used, a [`BloqadeWaveforms.constant`](@ref) waveform should be created with value zero
to indicate non-use.

Note that not all atom position constraints are accounted for, such as the maximum lattice width, lattice height, 
and minimum supported spacings. Only position resolution is automatically accounted for.
This may result in the [`validation`](@ref) function failing and requiring user intervention to modify the atom 
positions such that they satisfy the other constraints.

# Logs/Warnings/Exceptions

Debug logs are *always* emitted containing the error (defined as the 1-norm of the difference between
the original waveform and the transformed waveform) across all waveforms (Ω, Δ, ϕ) as well as the 
Mean Squared Error between the original atom positions and the adjusted atom positions.

The debug logs/warnings from constituent functions [`hardware_transform_Ω`](@ref),
[`hardware_transform_Δ`](@ref), [`hardware_transform_ϕ`](@ref) are also emitted should the 
waveforms in `h` cause them to.

See also [`hardware_transform_atoms`](@ref), [`hardware_transform_Ω`](@ref),
[`hardware_transform_Δ`](@ref), [`hardware_transform_ϕ`](@ref).

# Examples
```jldoctest; setup:=(using BloqadeExpr, BloqadeLattices)
julia> atom_positions = AtomList([(1.12,), (2.01,), (3.01,)]);

julia> Δ = Ω = ϕ = sinusoidal(duration=2, amplitude=1.3*π);

julia> h = rydberg_h(atom_positions; Ω=Ω,Δ=Δ,ϕ=ϕ)
nqubits: 3
+
├─ [+] ∑ 2π ⋅ 8.627e5.0/|x_i-x_j|^6 n_i n_j
├─ [+] Ω(t) ⋅∑ e^{ϕ(t) ⋅ im} |0⟩⟨1| + e^{-ϕ(t) ⋅ im} |1⟩⟨0|
└─ [-] Δ(t) ⋅ ∑ n_i


julia> hardware_transform(h)
(nqubits: 3
+
├─ [+] ∑ 2π ⋅ 8.627e5.0/|x_i-x_j|^6 n_i n_j
├─ [+] Ω(t) ⋅∑ e^{ϕ(t) ⋅ im} |0⟩⟨1| + e^{-ϕ(t) ⋅ im} |1⟩⟨0|
└─ [-] Δ(t) ⋅ ∑ n_i
, BloqadeSchema.HardwareTransformInfo(0.5386117854062276, 2.632451578170084, 0.06492452289703464, (Δ = Waveform(_, 2), δ = nothing, Δi = 1.0), 0.013333333333333197))
```
"""
function hardware_transform(h::BloqadeExpr.RydbergHamiltonian;device_capabilities::DeviceCapabilities=get_device_capabilities())
    # gets transformed versions of waveforms, then creates new hamiltonian    
    atoms,ϕ,Ω,Δ,info = hardware_transform_parse(h,device_capabilities)
    hardware_h = rydberg_h(atoms,ϕ=ϕ,Ω=Ω,Δ=Δ)

    @debug "Hardware transform report: after linear interpolation ∫dt |ϕ(t)-ϕ_hw(t)| = $(info.ϕ_error) rad⋅μs"
    @debug "Hardware transform report: after linear interpolation ∫dt |Ω(t)-Ω_hw(t)| = $(info.Ω_error) rad"
    @debug "Hardware transform report: after linear interpolation ∫dt |Δ(t)-Δ_hw(t)| = $(info.Δ_error) rad"
    @debug "Hardware transform report: mean deviation after rounding positions $(info.mse_atoms) μm"

    return hardware_h,info
end

using Test
using BloqadeWaveforms
using BloqadeExpr
using BloqadeSchema:
    schema_parse_pwl_field,
    schema_parse_pwc_field,
    schema_parse_rydberg_fields


@testset "schema_parse_pwl_field" begin
    wf = piecewise_linear(;clocks=[0,2,3,4],values=[1,2,3,4])
    @test schema_parse_pwl_field(:wf,wf) == wf
    
    wf = Waveform(t->t^2,1)
    @test_throws ErrorException schema_parse_pwl_field(:wf,wf)
end

@testset "schema_parse_pwc_field" begin
    wf = piecewise_constant(;clocks=[0,2,3,4],values=[1,2,3])
    @test schema_parse_pwc_field(:wf,wf) == wf
    
    wf = Waveform(t->t^2,1)
    @test_throws ErrorException schema_parse_pwc_field(:wf,wf)
end

@testset "schema_parse_rydberg_fields" begin
    Ω = piecewise_linear(;clocks=Float64[0,1,2,3],values=Float64[0,1,1,0])
    Δ = piecewise_linear(;clocks=Float64[0,1,2,3],values=Float64[1,1,-1,-1])
    ϕ = piecewise_constant(;clocks=Float64[0,1,2,3],values=Float64[0,1,-1])
    atoms = [(5.0*i,0.0) for i in 1:10]
    h = rydberg_h(atoms, Ω=Ω, Δ=Δ, ϕ=ϕ)

    @test schema_parse_rydberg_fields(h) == (atoms,ϕ,Ω,Δ,nothing,1.0)

    
    
end

using BloqadeSchema
using Bloqade
using JSON


# 6 atoms positioned at the edge of the addressable area
device_capabilities = get_device_capabilities()
max_width = device_capabilities.lattice.area.width
max_height = device_capabilities.lattice.area.height

atoms = AtomList([(0.0, 0.0), (0, max_height), (max_width, max_height), 
                  (max_width, 0), (max_width, max_height/2), (0, max_height/2)])

T=1
Δ = Waveform(t->cos(2π*t/T),T)
Δi=Δ
Ω = Waveform(t->sin(2π*t/T)^2,T)
ϕ = constant(;duration=T,value=0)

h = rydberg_h(atoms;Ω=Ω,Δ=Δi,ϕ=ϕ)
h_hardware, info = hardware_transform(h)
h = to_json(h_hardware)

open("lib/BloqadeSchema/schema_examples/aws_science_tasks/lattice_programmability/lattice1.json","w") do f
    JSON.print(f, JSON.parse(h))
end

using OrderedCollections: OrderedDict

function Configurations.to_dict(
    ::Type{T},
    x::Union{RabiFrequencyAmplitude,RabiFrequencyPhase},
    option::Configurations.ToDictOption,
) where {T}
    return Dict("global" => Configurations.to_dict(x.global_value))
end

function Configurations.to_dict(::Type{T}, x::Union{Detuning,RydbergCapabilities}, option::Configurations.ToDictOption) where {T}
    if isnothing(x.local_value)
        return OrderedDict("global" => Configurations.to_dict(x.global_value))
    end

    return OrderedDict("global" => Configurations.to_dict(x.global_value), "local" => Configurations.to_dict(x.local_value))
end


function Configurations.to_dict(::Type{T}, x::Lattice, option::Configurations.ToDictOption) where {T}
    return OrderedDict("sites" => map(collect, x.sites), "filling" => x.filling)
end

abstract type QuEraCapabilities end

# copying structure from device API 

# make field mutable for user to change parameters

@option mutable struct LatticeAreaCapabilities <: QuEraCapabilities 
    width::Float64
    height::Float64
end

@option mutable struct LatticeGeometryCapabilities <: QuEraCapabilities 
    spacing_radial_min::Float64
    spacing_vertical_min::Float64
    position_resolution::Float64
    number_sites_max::Int
end

@option mutable struct LatticeCapabilities <: QuEraCapabilities 
    area::LatticeAreaCapabilities
    geometry::LatticeGeometryCapabilities
    number_qubits_max::Int
end

# non snake case is from API
@option mutable struct RydbergGlobalCapabilities <: QuEraCapabilities 
    rabi_frequency_min::Float64
    rabi_frequency_max::Float64
    rabi_frequency_resolution::Float64
    rabi_frequency_slew_rate_max::Float64
    detuning_min::Float64
    detuning_max::Float64
    detuning_resolution::Float64
    detuning_slew_rate_max::Float64
    phase_min::Float64
    phase_max::Float64
    phase_resolution::Float64
    time_min::Float64
    time_max::Float64
    time_resolution::Float64
    time_delta_min::Float64
end

@option mutable struct RydbergLocalCapabilities <: QuEraCapabilities 
    detuning_min::Float64
    detuning_max::Float64
    common_detuning_resolution::Float64
    local_detuning_resolution::Float64
    detuning_slew_rate_max::Float64
    number_local_detuning_sites::Int
    spacing_radial_min::Float64
    time_resolution::Float64
    time_delta_min::Float64
end

@option struct RydbergCapabilities <: QuEraCapabilities 
    c6_coefficient::Float64
    global_value::RydbergGlobalCapabilities
    local_value::Maybe{RydbergLocalCapabilities}
end

@option mutable struct TaskCapabilities <: QuEraCapabilities 
    number_shots_min::Int 
    number_shots_max::Int
end

@option struct DeviceCapabilities <: QuEraCapabilities
    task::TaskCapabilities
    lattice::LatticeCapabilities
    rydberg::RydbergCapabilities
end

using BloqadeSchema
using Bloqade
using JSON

# Switching rapidly between 0 and non-zero detuning, while also switching rapidly, in sync, between maximal and zero rabi frequency.
# The result should be identical to applying a continuous rabi pulse over a timeframe when the detuning was zero.

atoms = AtomList([(0.0, 0.0)])

T1=1
T2=2.5
Ω = piecewise_constant(clocks=[0.0, T1, T2], values= 2π*[0.0, 4])

# maximal detuning 
Δ = piecewise_constant(clocks=[0.0, T1, T2], values= 2π*[20, 0])

ϕ = constant(;duration=T2, value=0)

h = rydberg_h(atoms;Ω=Ω, Δ=Δ, ϕ=ϕ)

# hardware_transform will add slopes between values in waveform when necessary
# with the maximum slew rate supported by hardware
h_hardware,info  = hardware_transform(h)
h = to_json(h_hardware)

open("lib/BloqadeSchema/schema_examples/aws_science_tasks/global_rydberg/global4.json","w") do f
    JSON.print(f, JSON.parse(h))
end

# helper functions to generate violations

message(::typeof(>)) = "exceeds maximum"
message(::typeof(<)) = "below minimum"
message(::typeof(!=)) = "is not equal to the"

# checks of x is integer multiple of res
# if it is return false otherwise return true
function check_resolution(res::Real,x::Real) 
    x == 0 && return false

    x_div_res = (abs(x) / res)
    return !isapprox(round(x_div_res),x_div_res)
end

function group_by_key(itr,key)
    groups = Dict{Any,Set}()

    foreach(enumerate(itr)) do (i,value)
        key_value = value[key]
        if haskey(groups,key_value)
            push!(groups[key_value],i)
        else
            groups[key_value] = Set([i])
        end
    end

    return groups
end

# TODO: implement this test based on validation in TaskManager
function validate_lattice(positions,dc::DeviceCapabilities)

    positions = map(positions) do position
        if length(position) == 1
            (position[1],0.0)
        else
            position
        end
    end

    violations = Set([])

    # valudate number of sites (qubits)
    nqubits = length(positions)
    nqubits_max = dc.lattice.number_qubits_max
    nqubits > nqubits_max && push!(violations,
        "$nqubits qubits $(message(>)) of $nqubits_max qubits"
    )

    # validate resolution
    position_resolution = dc.lattice.geometry.position_resolution
    foreach(enumerate(positions)) do (i,position)
        any(check_resolution.(position_resolution,position)) && push!(violations,
            "$(i)th atom position $position not consistent with position resolution: $position_resolution"
        )
    end

    # validate area

    xmin = minimum(pos->pos[1],positions)
    xmax = maximum(pos->pos[1],positions)
    ymin = minimum(pos->pos[2],positions)
    ymax = maximum(pos->pos[2],positions)

    width = xmax-xmin

    height = ymax-ymin
    max_width = dc.lattice.area.width
    max_height = dc.lattice.area.height
    width > max_width && push!(violations,
        "total width $width μm $(message(>)) value of $max_width μm"
    )
    height > max_height && push!(violations,
        "total height $height μm $(message(>)) value of $max_height μm"
    )

    # validate radial spacing
    radial_spacing_min = dc.lattice.geometry.spacing_radial_min
    for i in 1:nqubits, j in i+1:nqubits
        x_i,y_i = positions[i]
        x_j,y_j = positions[j]
        radial_spacing = hypot(x_i-x_j,y_i-y_j)
        atom_1 = i => (x_i,y_i)
        atom_2 = j => (x_j,y_j)
        radial_spacing < radial_spacing_min && push!(violations,
            "positions $atom_1 and $atom_2 are a distance of $radial_spacing μm apart which is $(message(<)) value of $radial_spacing_min μm"
        )
        
    end

    # validate vertical spacing

    y_groups = group_by_key(positions,2)
    y_values = collect(keys(y_groups))
    sort!(y_values)
    zip_with_next = zip(y_values[1:end-1],y_values[2:end])
    vertical_resolution = dc.lattice.geometry.spacing_vertical_min

    foreach(zip_with_next) do (y0,y1)
        if !(abs(y0-y1) > vertical_resolution || abs(y0-y1) ≈ vertical_resolution)
            sites = collect(union(y_groups[y0],y_groups[y1]))
            sorted_sites = sort(sites)
            error_sites = join([site=>positions[site] for site in sorted_sites],", ")
            push!(violations,
                "positions {$(error_sites)} violate y minimum value of $vertical_resolution μm"
            )

        end
    end

    return violations

end

# Waveform Validations all waveforms must be piecewise linear


# TODO: add explicit typing, wf::Waveform{BloqadeWaveforms.PiecewiseLinear{T,I},T} where {T<:Real,I}
function validate_Ω(wf,expected)
    
    max_time = wf.duration
    max_value = maximum(wf.f.values)
    min_value = minimum(wf.f.values)
    min_time_step  = round(minimum(diff(wf.f.clocks));sigdigits=14)
    max_slope = round(maximum(abs.(diff(wf.f.values))./diff(wf.f.clocks));sigdigits=14)
    start_value = wf.f.values[1]
    end_value = wf.f.values[end]

    tests = [
        ("duration",max_time,>,expected.max_time,"μs"),
        ("duration",max_time,<,expected.min_time_step,"μs"),
        ("minimum step",min_time_step,<,expected.min_time_step,"μs"),
        ("maximum slope",max_slope,>,expected.max_slope,"rad/μs²"),
        ("minimum value",min_value,<,expected.min_value,"rad/μs"),
        ("maximum value",max_value,>,expected.max_value,"rad/μs"),
        ("start value",start_value,!=,0.0,"rad/μs"),
        ("end value",end_value,!=,0.0,"rad/μs"),
    ]
    #("duration", max_time, < expected.min_time_step, "μs")
    violations = Set([])

    for (name,given,op,expected,units) in tests
        op(given,expected) && push!(violations,"Ω(t) $name with value $given $units $(message(op)) value of $expected $units")
    end

    foreach(wf.f.clocks) do clock
        check_resolution(expected.time_resolution,clock) && push!(violations,"Ω(t) clock $clock μs is not consistent with resolution $(expected.time_resolution) μs.")
    end

    foreach(wf.f.values) do value
        check_resolution(expected.value_resolution,value) && push!(violations,"Ω(t) value $value rad/μs is not consistent with resolution $(expected.value_resolution) rad/μs.")
    end

    return violations

end

function validate_Δ(wf,expected)
    
    max_time = wf.duration
    max_value = maximum(wf.f.values)
    min_value = minimum(wf.f.values)
    min_time_step  = round(minimum(diff(wf.f.clocks));sigdigits=14)
    max_slope = round(maximum(abs.(diff(wf.f.values))./diff(wf.f.clocks));sigdigits=14)


    tests = [
        ("duration",max_time,>,expected.max_time,"μs"),
        ("duration",max_time,<,expected.min_time_step,"μs"),
        ("minimum step",min_time_step,<,expected.min_time_step,"μs"),
        ("maximum slope",max_slope,>,expected.max_slope,"rad/μs²"),
        ("minimum value",min_value,<,expected.min_value,"rad/μs"),
        ("maximum value",max_value,>,expected.max_value,"rad/μs"),
    ]

    violations = Set([])

    for (name,given,op,expected,units) in tests
        op(given,expected) && push!(violations,"Δ(t) $name with value $given $units $(message(op)) value of $expected $units")
    end

    foreach(wf.f.clocks) do clock
        check_resolution(expected.time_resolution,clock) && push!(violations,"Δ(t) clock $clock μs is not consistent with resolution $(expected.time_resolution) μs.")
    end

    foreach(wf.f.values) do value
        check_resolution(expected.value_resolution,value) && push!(violations,"Δ(t) value $value rad/μs is not consistent with resolution $(expected.value_resolution) rad/μs.")
    end

    return violations

end

function validate_ϕ(wf,expected)

    max_time = wf.duration
    max_value = maximum(wf.f.values)
    min_value = minimum(wf.f.values)
    min_time_step  = round(minimum(diff(wf.f.clocks));sigdigits=14)
    start_value = wf.f.values[1]


    tests = [
        ("duration",max_time,>,expected.max_time,"μs"),
        ("duration",max_time,<,expected.min_time_step,"μs"),
        ("minimum step",min_time_step,<,expected.min_time_step,"μs"),
        ("minimum value",min_value,<,expected.min_value,"rad"),
        ("maximum value",max_value,>,expected.max_value,"rad"),
        ("start value",start_value,!=,0.0,"rad"),
    ]

    violations = Set([])

    for (name,given,op,expected,units) in tests
        op(given,expected) && push!(violations,"ϕ(t) $name with value $given $units $(message(op)) value of $expected $units")
    end

    foreach(wf.f.clocks) do clock
        check_resolution(expected.time_resolution,clock) && push!(violations,"ϕ(t) clock $clock μs is not consistent with resolution $(expected.time_resolution) μs.")
    end

    foreach(wf.f.values) do value
        check_resolution(expected.value_resolution,value) && push!(violations,"ϕ(t) value $value rad is not consistent with resolution $(expected.value_resolution) rad.")
    end

    return violations
end

function validate_δ(wf,Δi,expected)

    max_time = wf.duration
    max_value = maximum(wf.f.values)
    min_value = minimum(wf.f.values)
    min_time_step  = round(minimum(diff(wf.f.clocks));sigdigits=14)
    max_slope = round(maximum(abs.(diff(wf.f.values))./diff(wf.f.clocks));sigdigits=14)


    tests = [
        ("duration",max_time,>,expected.max_time,"μs"),
        ("duration",max_time,<,expected.min_time_step,"μs"),
        ("minimum step",min_time_step,<,expected.min_time_step,"μs"),
        ("minimum step",min_time_step,>,max_time,"μs"),
        ("maximum slope",max_slope,>,expected.max_slope,"rad/μs²"),
        ("minimum value",min_value,<,expected.min_value,"rad/μs"),
        ("maximum value",max_value,>,expected.max_value,"rad/μs"),
    ]

    violations = Set([])

    for (name,given,op,expected,units) in tests
        op(given,expected) && push!(violations,"δ(t) $name with value $given $units $(message(op)) value of $expected $units")
    end

    foreach(wf.f.clocks) do clock
        check_resolution(expected.time_resolution,clock) && push!(violations,"δ(t) clock $clock μs is not consistent with resolution $(expected.time_resolution) μs.")
    end

    foreach(wf.f.values) do value
        check_resolution(expected.value_resolution,value) && push!(violations,"δ(t) value $value rad is not consistent with resolution $(expected.value_resolution) rad.")
    end

    foreach(Δi) do value
        check_resolution(expected.local_mask_resolution,value) && push!(violations,"Δi value $value  is not consistent with resolution $(expected.local_mask_resolution).")
    end

    return violations
end

function check_durations(ϕ,Ω,Δ,δ)
    durations = Dict(:Δ=>Δ.duration,:Ω=>Ω.duration,:ϕ=>ϕ.duration)
    
    invalid = Set([])

    if !isnothing(δ)
        durations[:δ] = δ.duration
    end

    for (f1,d1) in durations
        for (f2,d2) in durations
           d1!=d2 && push!(invalid,Set([f1=>d1,f2=>d2]))
        end
    end

    violations = Set([])

    for ((f1,d1),(f2,d2)) in invalid
        if d2>d1
            push!(violations,"$f2(t) duration of $d2 μs is greater than $f1(t) duration of $d1 μs")
        else
            push!(violations,"$f1(t) duration of $d1 μs is greater than $f2(t) duration of $d2 μs")
        end
    end

    return violations
end

function validate_analog_params(atoms,ϕ,Ω,Δ,δ,Δi,device_capabilities::DeviceCapabilities)
    
    lattice_violations = validate_lattice(atoms,device_capabilities)
    rydberg_capabilities = get_rydberg_capabilities(;device_capabilities=device_capabilities)

    ϕ_violations = validate_ϕ(ϕ,rydberg_capabilities.ϕ)
    Ω_violations = validate_Ω(Ω,rydberg_capabilities.Ω)
    Δ_violations = validate_Δ(Δ,rydberg_capabilities.Δ)
    
    δ_violations = if !isnothing(δ)
        validate_δ(δ,Δi,rydberg_capabilities.δ)
    else
        Set([])
    end

    misc_violations = check_durations(ϕ,Ω,Δ,δ)

    return ValidationViolations(;lattice_violations=lattice_violations,
        misc_violations=misc_violations,
        Δ_violations=Δ_violations,
        δ_violations=δ_violations,
        Ω_violations=Ω_violations,
        ϕ_violations=ϕ_violations
    )
end

# public API exposed here
"""
    validate(H::BloqadeExpr.RydbergHamiltonian;device_capabilities::DeviceCapabilities=get_device_capabilities())

Checks if `H` is capable of being represented as part of the internal schema as well as if it falls
in the capabilities of what the machine can do via `device_capabilities`.

Returns [`ValidationViolations`](@ref) with each field containing a set of strings indicating which
constraints were violated for which part of `H`.

Violations include:

## Waveform Type
* ϕ is not of type `PiecewiseConstantWaveform`
* Ω and Δ are not of type `PiecewiseLinearWaveform`
## Atom Position
* Number of qubits requested exceeds what is supported by the device
* Atom positions exceed position resolution supported by the device
* The total width/height of the atom arrangement exceeds what is supported by the device
* The radial spacing between atoms is smaller than what is supported by the device
* The vertical row spacing between atoms is smaller than what is supported by the device
## General Waveform Constraints (apply to Ω, Δ, ϕ)
* duration exceeds device supported duration
* duration is smaller than device supported minimum time step
* smallest time step is smaller than supported smallest time step
* value is smaller than smallest supported value
* value is larger than largest supported value
## Ω Waveform specific constraints
* Slope exceeds largest supported slope
* Start and end values are not equal to 0.0 rad/μs
## Δ Waveform specific constraints
* Slope exceeds largest supported slope
## ϕ Waveform specific constraints
* start value is not equal to 0.0 rad/μs

# Logs/Warnings/Exceptions

The following exceptions can be thrown:
* ϕ is not of type `PiecewiseConstantWaveform`
* Ω and Δ are not of type `PiecewiseLinearWaveform`

# Examples
```jldoctest; setup:=(using BloqadeExpr, BloqadeWaveforms, BloqadeLattices)
julia> Δ = Ω = ϕ = sinusoidal(duration=2, amplitude=1.3*π);

julia> h = rydberg_h(atom_positions; Ω=Ω,Δ=Δ,ϕ=ϕ)

julia> transformed_h, _ = transform(h); # transform returns error info

julia> validate(transformed_h) # constrained by default value of `device_capabilities` argument
The following validation violations occurred:

1. positions 2 => (2.0, 0.0) and 3 => (3.0, 0.0) are a distance of 1.0 μm apart which is below minimum value of 4.0 μm
2. positions 1 => (1.1, 0.0) and 2 => (2.0, 0.0) are a distance of 0.8999999999999999 μm apart which is below minimum value of 4.0 μm
3. positions 1 => (1.1, 0.0) and 3 => (3.0, 0.0) are a distance of 1.9 μm apart which is below minimum value of 4.0 μm
``` 
"""
function validate(H::BloqadeExpr.RydbergHamiltonian;device_capabilities::DeviceCapabilities=get_device_capabilities())
    (atoms,ϕ,Ω,Δ,δ,Δi) = schema_parse_rydberg_fields(H)

    return validate_analog_params(atoms,ϕ,Ω,Δ,δ,Δi,device_capabilities)

end

"""
    rydberg_density(task_res::AnalogHamiltonianSimulationQuantumTaskResult) -> Real

Return the rydberg density at each site given an `AnalogHamiltonianSimulationTaskResult`.
"""
rydberg_density(task_res::Braket.AnalogHamiltonianSimulationQuantumTaskResult) = sum(map(x -> 1 .- x.post_sequence, task_res.measurements)) / length(task_res.measurements)

"""
    rydberg_density(task_res::AnalogHamiltonianSimulationQuantumTaskResult, i::Int) -> Real


Return the rydberg density at site `i` given an `AnalogHamiltonianSimulationTaskResult`.
"""
rydberg_density(task_res::Braket.AnalogHamiltonianSimulationQuantumTaskResult, i::Int) = sum(map(x -> 1 .- x.post_sequence[i], task_res.measurements)) / length(task_res.measurements)

using BloqadeSchema
using Bloqade
using JSON


# No detuning, and using a rabi_frequency pulse strength for a longer time, and see how much coherence is lost due to longer evolution time.

atoms = AtomList([(0.0, 0.0)])

T=2
Ω = constant(;duration=T, value=6π)
ϕ = constant(;duration=T, value=0)
Δ = constant(;duration=T, value=0)

h = rydberg_h(atoms;Ω=Ω,ϕ=ϕ,Δ=Δ)
h_hardware,info = hardware_transform(h)
h = to_json(h_hardware)


open("lib/BloqadeSchema/schema_examples/aws_science_tasks/global_rydberg/global2.json","w") do f
    JSON.print(f, JSON.parse(h))
end

"""
    submit_to_braket(h::BloqadeExpr.Hamiltonian, n_shots::Int; <keyword arguments>)

Submits a `BloqadeExpr.RydbergHamiltonian` instance to Braket with `n_shots` defining the number of times
the Hamiltonian should be executed. 

Credentials can be passed in explicitly through an `AWS.AWSCredentials` struct or by passing in 
`nothing`, in which case credentials will be sought in the standard AWS locations.

# Keyword Arguments
- `arn="arn:aws:braket:us-east-1::device/qpu/quera/Aquila"`: ARN for the machine
- `region="us-east-1"`: AWS Region machine is located in
- `credentials::Union{AWSCredentials, Nothing}=nothing`: `AWS.AWSCredentials` instance you can create to login.

# Logs/Warnings/Exceptions

An `AWS.NoCredentials` exception is thrown containing a `message` string "Can't find AWS credentials!" if the credentials given are invalid.

[`BloqadeSchema.hardware_transform`](@ref) is always invoked, meaning its debug logs are also always emitted containing the difference (error)
between the original waveforms in `h` and the newly generated ones compatible with hardware as well as the same transformation for atom positions.
"""
function submit_to_braket(h::BloqadeExpr.RydbergHamiltonian, 
                          n_shots::Int, 
                          device_capabilities = BloqadeSchema.get_device_capabilities();
                            arn="arn:aws:braket:us-east-1::device/qpu/quera/Aquila",
                            region="us-east-1",
                            credentials::Union{AWSCredentials, Nothing}=nothing
                        ) 
    # is a BloqadeSchema.QuEraTaskSpecification instance, can call the other function
    translation_params = BloqadeSchema.SchemaTranslationParams(
        n_shots,
        device_capabilities
    )
    return submit_to_braket(h, translation_params; arn=arn, region=region, credentials=credentials)
end

"""
    submit_to_braket(h::BloqadeExpr.RydbergHamiltonian, translation_params::BloqadeSchema.SchemaTranslationParams; <keyword arguments>)

Submits a `BloqadeExpr.RydbergHamiltonian` instance to Braket with `BloqadeSchema.SchemaTranslationParams` containing the number of shots and 
device capabilities. Returns an `AWS.AwsQuantumTask` upon converting the Hamiltonian to one the hardware can execute and submitting it.

Credentials can be passed in explicitly through an `AWS.AWSCredentials` struct or by passing in 
`nothing`, in which case credentials will be sought in the standard AWS locations.

# Keyword Arguments
- `arn="arn:aws:braket:us-east-1::device/qpu/quera/Aquila"`: ARN for the machine
- `region="us-east-1"`: AWS Region machine is located in
- `credentials::Union{AWSCredentials, Nothing}=nothing`: `AWS.AWSCredentials` instance you can create to login.

# Logs/Warnings/Exceptions

An `AWS.NoCredentials` exception is thrown containing a `message` string "Can't find AWS credentials!" if the credentials given are invalid.

[`hardware_transform`](@ref) is always invoked internally, meaning its debug logs are also always emitted containing the difference (error)
between the original waveforms in `h` and the newly generated ones compatible with hardware as well as the same transformation for atom positions.
"""
function submit_to_braket(h::BloqadeExpr.RydbergHamiltonian,
                          translation_params::BloqadeSchema.SchemaTranslationParams;
                            arn="arn:aws:braket:us-east-1::device/qpu/quera/Aquila",
                            region="us-east-1",
                            credentials::Union{AWSCredentials, Nothing}=nothing
                        )

    # Transform error info is output via @debug
    h_transformed, _ = hardware_transform(h)
    bloqade_ir = BloqadeSchema.to_schema(h_transformed, translation_params)
    task = submit_to_braket(bloqade_ir; arn=arn, region=region, credentials=credentials)
    return task
end

"""
    sumbit_to_braket(ts:BloqadeSchema.QuEraTaskSpecification; <keyword arguments>)

Submits a `BloqadeSchema.QuEraTaskSpecification` instance to Braket, returning an `AWS.AwsQuantumTask`.

Credentials can be passed in explicitly through an `AWS.AWSCredentials` struct or by passing in 
`nothing`, in which case credentials will be sought in the standard AWS locations.

# Keyword Arguments
- `arn="arn:aws:braket:us-east-1::device/qpu/quera/Aquila"`: ARN for the machine
- `region="us-east-1"`: AWS Region machine is located in
- `credentials::Union{AWSCredentials, Nothing}=nothing`: `AWS.AWSCredentials` instance you can create to login.

# Logs/Warnings/Exceptions

An `AWS.NoCredentials` exception is thrown containing a `message` string "Can't find AWS credentials!" if the credentials given are invalid.
"""
function submit_to_braket(ts::BloqadeSchema.QuEraTaskSpecification; 
        arn="arn:aws:braket:us-east-1::device/qpu/quera/Aquila", 
        region="us-east-1",
        credentials::Union{AWSCredentials, Nothing}=nothing)
    # may need region provided, don't think we have to worry about output

    aws_config = if !isnothing(credentials)
        AWSConfig(;creds=credentials, region=region)
    else
        # default to environment variables
        AWSConfig(;region=region)
    end
    
    qpu = Braket.AwsDevice(arn; config = aws_config)
    braket_ir = to_braket_ahs_ir(ts)
    task = qpu(braket_ir;shots=ts.nshots)
    
    return task
end

function Configurations.from_dict(::Type{Lattice}, ::Type{NTuple{2,Float64}}, x)
    return (x[1], x[2])
end

function Configurations.from_dict(::Type{RabiFrequencyAmplitude}, d::AbstractDict{String,<:Any})
    return RabiFrequencyAmplitude(Configurations.from_dict(GlobalField, d["global"]))
end

function Configurations.from_dict(::Type{RabiFrequencyPhase}, d::AbstractDict{String,<:Any})
    return RabiFrequencyPhase(Configurations.from_dict(GlobalField, d["global"]))
end

function Configurations.from_dict(::Type{Detuning}, d::AbstractDict{String,<:Any})

    return if haskey(d, "local")
        Detuning(
            global_value=Configurations.from_dict(GlobalField, d["global"]),
            local_value=Configurations.from_dict(LocalField, d["local"])
        )
    else
        Detuning(global_value = Configurations.from_dict(GlobalField, d["global"]), local_value = nothing)
    end
end

function Configurations.from_dict(::Type{RydbergCapabilities}, d::AbstractDict{String,<:Any})
    return if haskey(d, "local")
        RydbergCapabilities(
            c6_coefficient=d["c6_coefficient"],
            global_value=Configurations.from_dict(RydbergGlobalCapabilities, d["global"]),
            local_value=Configurations.from_dict(RydbergLocalCapabilities, d["local"])
        )
    else
        RydbergCapabilities(c6_coefficient=d["c6_coefficient"],global_value = Configurations.from_dict(RydbergGlobalCapabilities, d["global"]), local_value = nothing)
    end
end

abstract type QuEraSchema end

@option struct Lattice <: QuEraSchema
    sites::Vector{Tuple{Float64,Float64}}
    filling::Vector{Int32}
end

@option struct GlobalField <: QuEraSchema
    times::Vector{Float64}
    values::Vector{Float64}
end

@option struct LocalField <: QuEraSchema
    times::Vector{Float64}
    values::Vector{Float64}
    lattice_site_coefficients::Vector{Float64}
end

@option struct RabiFrequencyAmplitude <: QuEraSchema
    global_value::GlobalField
end

@option struct RabiFrequencyPhase <: QuEraSchema
    global_value::GlobalField
end

@option struct Detuning <: QuEraSchema
    global_value::GlobalField
    local_value::Maybe{LocalField}
end

@option struct RydbergHamiltonian <: QuEraSchema
    rabi_frequency_amplitude::RabiFrequencyAmplitude
    rabi_frequency_phase::RabiFrequencyPhase
    detuning::Detuning
end

@option struct EffectiveHamiltonian <: QuEraSchema
    rydberg::RydbergHamiltonian
end

"""
    struct QuEraTaskSpecification <: QuEraSchema

The schema representation of a task for the machine.

Is the output of [`to_schema`](@ref) and [`to_schema_no_validation`](@ref)
as well as input to [`execute(task::QuEraTaskSpecification)`](@ref).

# Fields
- `nshots::Int`: Number of shots (number of times hamiltonian is executed)
- `lattice::Lattice`: The Bravais lattice vectors and sites
- `effective_hamiltonian::EffectiveHamiltonian`: a `RydbergHamiltonian` instance 
wrapped inside an `EffectiveHamiltonian`
"""
@option struct QuEraTaskSpecification <: QuEraSchema
    nshots::Int
    lattice::Lattice
    effective_hamiltonian::EffectiveHamiltonian
end
